#define FALSE 0
#define TRUE  1

#define MAIN_POST    1		/* create postcript for main or zoom */
#define ZOOM_POST    2		/* used in general_post, create_post */

#define SMALLEST_ENERGY  -9999999 /* should be < any energy in plot */
/* file
 * MAXIMUM_HELICES  is the total number of entries in the plot files
 * Plus extra helices for overlap, and splits */

#define TOTAL_COLORS 22
#define COLOR_TEXT 8
#define COLOR_COMP 7
#define COLOR_GRID 9
#define COLOR_LABEL 10
#define COLOR_BACK 11
#define COLOR_CLOSE 12
#define COLOR_C 14
#define COLOR_A 13
#define COLOR_G 15
#define COLOR_U 16
#define COLOR_ELSE 17
#define COLOR_DOT 18
#define COLOR_TEXT_BACKGROUND 19
#define COLOR_HELIX_ALIGN 20
#define COLOR_GRID_FINE 21

#define TOTAL_SEQUENCES 7 /* 5 are real, plus partial and full overlap */

/* Adjust MAXIMUM_SIZE and MAXIMUM_HELICES upward for large data
 * Original values for MAXIMUM_SIZE 10500 , MAXIMUM_HELICES 750000 
 */
#define MAXIMUM_SIZE 31000 /* LARGEST SEQUENCE ALLOWED
			    * = 0.97*MAXIMUM_SIZE alignment lengths <
			    * (0.97*MAXIMUM_SIZE ) are allowed  */ 

#define MAXIMUM_HELICES 4000000	/* This may need to be adjusted */
/* The above includes helices from plot files, ct_files and
 * the helices created from overlap of the above helices
 * Any insertion that splits a helix will make the helix count
 * as at least 2 helices.
 * 750000 seems to work for 5 sequences of length of 10,000
 * It is highly dependent on the size of the plot files 
 */

int             g_type_of_dump;
int             g_annotation_flag;
int             g_prob_annotation_flag;
int             g_ann_num_colors;
int             g_no_partial_flag;

int             g_type_of_label_file; /* use 0 for detail of all sequences */
/* use sequence number otherwise for base pairs for UNAFold or mfold */
int             g_first_zoom = 0; /* For unzoom: 0 indicates none to undo */
int             g_drag_helix_set;
int             g_drag_helix_below_diagonal;
int             g_drag_helix_sel_row;
int             g_drag_helix_sel_col;
int             g_drag_helix_mov_x;
int             g_drag_helix_mov_y;
int             g_drag_helix_sel_length;
int             g_drag_helix_front_length;
int             g_number_inserts;
int             g_big_dots_flag;
int             g_ps_multicolor_dots_flag;
int             g_grid_flag;
int             g_base_color_mode;
int             g_level_undos;
int             g_comp_flag;
int             g_zoom_comp;	/* the number of compensating bases
				 * in zoom window */
int             g_comp;	/* the number of compensating bases in main
			 * window */

int             g_mouse_motion;
int             g_row_line = FALSE;
int             g_col_line = FALSE;

/* these are the current width and height of the main window  in pixels */
int             width = 800, height = 800;
int             width_z = 750, height_z = 750;	/* same for zoom window */

int             g_which_window_i_am_in;	/* which window the cursor is in */

/* when right mouse button is clicked, transform coordinates into i,j */

int             g_zoom_region_exists;
int             g_unique_mode;	/* do not display black or gray dots */
int             g_bigdot_mode;	/* draw with bigger dotts when true */

/* edit complot.col for dot sizes and color preferences
 * keep track of the current color for text and 
 * borders $$$$$$$$ used in fixcolor()
 * This is now constant. 0 is black, 2 is yellow
 * 3 is green, see fixcolor_plot
 * ______________________________________________________________
 * Notice that most functions are called based on events in the
 * event queue.  They do not call each other.  This results in too
 * many global variables.
 * Variables that could easily be changed for personal preference are
 * usually accompanied by $$$.
 * ______________________________________________________________ 
 */

/* Font variables  ______________________________________________ */

void    *g_font_text = GLUT_BITMAP_HELVETICA_18; /* initialize font $$$$$$ */
void    *g_font_zoom = GLUT_BITMAP_HELVETICA_18;
void    *g_font_main = GLUT_BITMAP_HELVETICA_18;
void    *g_font_align = GLUT_BITMAP_HELVETICA_12;
void    *fonts[] = { /* used by selec_font */
  GLUT_BITMAP_HELVETICA_12,
  GLUT_BITMAP_HELVETICA_18,
  GLUT_BITMAP_TIMES_ROMAN_24
};

/* used with search option to determine how far to move helices, dots */
int             g_how_close_zoom = 0;	

/* Graphic  variables */

/* indicates number of points plotted in each window */
int             g_points_plotted, g_points_plotted_zoom;

/* all counts points where all sequences overlap, black dots
 * without all, counts points where has a base pair
 * zoom is for zoom window, other is for main window */
int             g_points_plotted_zoom_all;

int             g_points_plotted_ind[8];	/* for main window */

/* 0 is common and not used
 * 1 is partial overlap
 * 2-6 are sequences
 * 7 is close 
 */

/* Zoom Variables __________________________________________ */

/* specify boundaries of the zoom rectangle in i,j coordinates for
   main window or for the zoom window
*/
int     g_region_t=1, g_region_b=750, g_region_r=750, g_region_l=1;

/* screen coordinates of above (i,j) pairs  for the main window
   (blue rectangle)
*/ 
float   g_region_real_l, g_region_real_r, g_region_real_b, g_region_real_t;

float   g_region_real_l_zoom, g_region_real_r_zoom;
float   g_region_real_t_zoom, g_region_real_b_zoom;

/* Screen coordinates  for a zoom rectangle within the zoom window
 * nonzero indicates the top left corner of zoom region has been set 
 */
int             g_region_set;	
int             g_region_exists;

int             g_zoom_labels_count;	/* the number of labels used */
int             g_zoom_labels_x[50];	/* x coordinate for label i */
int             g_zoom_labels_xl[50];	/* used to plot on screen the
					 * dot */
int             g_zoom_labels_y[50];
int             g_zoom_labels_row[50];	/* row,col coordinates for labels */
int             g_zoom_labels_col[50];

char            g_zoom_labels_string[50][15];	/* value to place at x,y */

int             g_resolution;	/* 72 110 200 or 300 */
/* variables for making insertions in sequences with mouse */
int             g_col_insert_base_start;
float           g_col_insert_base_x_start_true;
int             g_col_insert_base_x_offset;
int             g_col_insert_base_x_start;
int             g_col_insert_sequence;
int             g_col_insert_base_on;	/* flag */
int             g_col_insert_base_final;
int             g_col_insert_base_x_safe;
int             g_col_insert_base_safe;
float           g_col_insert_row_start_y;

int             g_row_insert_base_start;
float           g_row_insert_base_y_start_true;
int             g_row_insert_base_y_offset;
int             g_row_insert_base_y_start;
int             g_row_insert_sequence;
int             g_row_insert_base_on;	/* flag */
int             g_row_insert_base_final;
int             g_row_insert_base_y_safe;
int             g_row_insert_base_safe;
float           g_row_insert_col_start_x;

/* File Variables _______________________________________________ */
char            rec[90];

char            g_post_filename[90];	/* for postscript file or
					 * label file */
int             g_prob;

int             g_zoom_window_exists = FALSE;
int             g_post_file;	/* 1 for main, 2 for zoom 
				 * used from text display */

struct backup_data {
  char           *sequence[7];
  int             length;
};

struct helix {
  int             row;
  int             column;
  int             diagonal;
  int             color;
  int             energy;
  int             length;
};

struct basepair {
  int             row;
  int             column;
};


int     step_fun(int, int);
int     start_fun(int, int);
int     check_compensate_char(char, char, char, char);
int     check_compensate(int, int);
char   *num_string_int(int);
char   *num_string_fancy_int(int);
int     find_base_color(char);
void    display_time(FILE *);
