/* include file for complot */

#define PLOT 1
#define FORCE 2

/* variables for drag with more than 2 sequences */

int g_primary_helix_index;  /* index of primary helix -1 is none */
int g_drag_this_row_from[TOTAL_SEQUENCES]; /* chosen row,col of this */
int g_drag_this_column_from[TOTAL_SEQUENCES]; /* sequences for drag */
int g_drag_this_column_to[TOTAL_SEQUENCES]; /* position within */
int g_drag_this_row_to[TOTAL_SEQUENCES]; /* primary helix */
/* -1 for g_drag_this_row_from[] indicates this sequence is not chosen */


int g_dot_lower_flag; /* use lower triangle for dot plots when true */

int win1,win2,win3,win4;    /* window indentifiers for glut*/
             /* 1 is main, 2 is zoom , 3 is text, 4 is align*/

/* data for back up feature
 * sequence 2-6 hold sequences 1-5
 * data is stored in 0 to length -1
 * require 12 of these 1 to 10 are backup states
 * 11 is current state */

/* alignment window variables */

int g_align_width;
int g_align_height;

int g_align_start_base;
int g_align_end_base;
int g_align_font_width;
int g_align_first_base_x;
int g_align_col_insert_base_on=FALSE;
int g_align_col_insert_base_start;
int g_align_col_insert_base_final;
int g_align_col_insert_base_x_start;
int g_align_col_insert_base_x_offset;
int g_align_col_insert_sequence;
int g_align_col_insert_base_x_safe;
int g_align_col_insert_base_safe;
int g_align_col_insert_base_x_offset;



/* extra variables for new rules for drag with 3 to 5 sequences */

#define DEFINED 1
#define UNDEFINED 0
#define PRIMARY 10

/* for below */ 
int g_drag_sequence_defined[TOTAL_SEQUENCES];
/* where was each non-primary sequence clicked */
int g_drag_sequence_defined_row[TOTAL_SEQUENCES];
int g_drag_sequence_defined_col[TOTAL_SEQUENCES];
/* where was it on the primary sequence ?*/
int g_drag_sequence_defined_row_p[TOTAL_SEQUENCES];
int g_drag_sequence_defined_col_p[TOTAL_SEQUENCES];
/* where is the start of each helix */
int g_drag_sequence_start_row[TOTAL_SEQUENCES];
int g_drag_sequence_start_col[TOTAL_SEQUENCES];
/* where is the end of each helix */
int g_drag_sequence_end_row[TOTAL_SEQUENCES];
int g_drag_sequence_end_col[TOTAL_SEQUENCES];


/* when order changes for backup, switch the order of the pointers */
/* 0 is temporary storage, 12 is temporarily storage  */

int g_last_diagonal;
int g_count_neighbors;
int g_neighbor_distance;
int g_count_nearby;
int g_nearby_distance;
int g_this_sequence=3; /* the sequence to compute best position for */
int g_primary_sequence;
int g_file_is_ct[TOTAL_SEQUENCES];
    /* indicates if each file is ct or plot*/

int g_file_is_skipped[TOTAL_SEQUENCES];

                /* True when none is used as name */
int g_count_sequences;  /* the number of sequences */
int g_adjust_count_sequences; 
int g_last_used_sequence; /* g_count_sequences+1 */
int g_adjust_last_used_sequence;
int g_total_undos;

char g_saved_alignment_name[120];

/* sequence 0 is black for full overlap
 * sequence 1 is gray for partial overlap
 * sequences 2-6 are the 1-5 entered sequences
 */

/* left, right, top, bottom, width and height for zoom window display
 * (in nucleotide coordinates) */
int g_display_l = 1, g_display_r = 700, g_display_t = 1, g_display_b = 700;
int  g_display_w = 700, g_display_h = 700; 

int g_saved_display_l, g_saved_display_r, g_saved_display_b, g_saved_display_t;

 /* above are used to back up 1 zoom window */

int g_i_row,g_j_col; /* for i.j base pair with mouse */

/* text window variables _________________________________________*/

int g_message_set = FALSE; /* Text display window shows text window
			      message when true. */

/* It indicates to enter postscript filename or energy increment */

/* values below for text_window_message based on g_message_set */

char *file_message =
  "Enter the PostScript file name (/ to abort), Default = "PROGRAM_NAME".ps)";
char *increment_message=
  "(/ to abort) Enter energy increment for " ;
char *label_message="Filename for Append of labels? (/ to abort) ";
char *gif_message=
  "Enter the gif file name (/ to abort), Default = "PROGRAM_NAME".gif) ";
char *png_message=
  "Enter the png file name (/ to abort), Default = "PROGRAM_NAME".png) ";
char *jpg_message=
  "Enter the jpg file name (/ to abort), Default = "PROGRAM_NAME".jpg)";
char *align_message_ps=
  "Enter name for alignment file (/ to abort), default: sequence_align.ps) ";
char *align_message_mal=
  "Enter name for alignment file (/ to abort), default:  ";
char *coordinate_message=
  "Enter coordinates and width for zoom window: row, col, width: ";

char text_window_message[110];
char text_window_input[120]; 
int data_entered = FALSE; /* for text display window */
int g_type_message; /* 1 for postscript file, 2 for energy increment 0
		       for none */ 

FILE *file;
FILE *afile;
char g_in_align_filename[120];
char g_out_align_filename[120];

/* current is 11 */
#define OVERLAP_JUMP 1.5
/* The number of helices for initial display is the number of helices
 * produced by reading plot file, making splits according to alignments
 * file.  It is assumed that extra helices for partial and full overlap
 * will not exceed 1.5 * the non-overlap number 
 */

char filename[120];
char fancy_align_filename[120];
char com_plot_filename[TOTAL_SEQUENCES][120]; /* for common plot files */
char g_label_default[TOTAL_SEQUENCES][120];
FILE *com_plot_fp; 
FILE *align_fp; 
char plot_filename[TOTAL_SEQUENCES][120]; /* for storing plot file names */
char plot_filename_short[TOTAL_SEQUENCES][120]; /* strip .plot suffix */
char g_sequence_name[TOTAL_SEQUENCES][120];
char *g_sequence_data[TOTAL_SEQUENCES];
char *g_sequence_data_new[TOTAL_SEQUENCES];
char *g_sequence_data_previous[TOTAL_SEQUENCES];
char *g_sequence_data_previous2[TOTAL_SEQUENCES];
char *g_sequence_data_original[TOTAL_SEQUENCES];
char *g_sequence_data_saved[TOTAL_SEQUENCES];

int *g_sequence_helix_used[TOTAL_SEQUENCES];
int g_sequence_helix_used_length[TOTAL_SEQUENCES];
int g_sequence_helix_used_row[TOTAL_SEQUENCES];
int g_sequence_helix_used_column[TOTAL_SEQUENCES];


int *g_sequence_data_same;

/* global sequence_data[i] is is the sequence from the alignment file
 * i - 1. It includes gaps.
 * global sequence_data_new is copied to g_sequence_data when
 * the program restarts
 * original is a copy of what is in the input alignment file
 * previous provides a way to go back to last alignment used
 */

int g_first_run; /* true, reads alignment, false uses new alignment */

/* translator [i][j] provides the location in the new sequence
 * that sequence i position j of original is mapped to
 * for ABCDEFGHIJ to  .ABC...DEF.GHI..J.. 
 * map is 1to 2 , 2 to 3, 3 to 4, 4 to 8, 5 to 9, 6 to 10,
 * 7 to 12, 8 to 13, 9 to 14, 10 to 17 
 */
int g_new_length;
int  g_sequence_translator[TOTAL_SEQUENCES][MAXIMUM_SIZE];
/* g_sequence_translator[i][j] sequence i-1,base j is located at this
   position within g_sequence_data[i] */  
int  g_reverse_st[TOTAL_SEQUENCES][MAXIMUM_SIZE];
/* maps g_sequence_data positions to bases of sequence without insertions 
 * Use 0 for dots, or undefined positions
 */

/* g_reverse_st[seq][j] returns where position j of the new sequence 
   was in the original sequence where seq from 2-6 */
int  g_nucleotide_total[TOTAL_SEQUENCES];
/* the total should  approximate  length from the plot file */
char general_sequence[MAXIMUM_SIZE];
int  g_sequence_length; /* aligned sequences must be this length,
			   including insertions */ 
int g_sequence_length_saved;
int g_sequence_length_original; /* for data from original aligment file */
int g_sequence_length_previous; /* used for reversing insertions */
int g_sequence_length_previous2;
int len; /* same as g_sequence_length */
int g_prob;
int g_diag_count[2*MAXIMUM_SIZE+1]; /* # of entries in each diagonal */
int g_diag_start[2*MAXIMUM_SIZE+1]; /* Where each diagonal starts */

int g_chain_len=1; /* helices smaller than this will not be displayed */
int g_optimal_energy[TOTAL_SEQUENCES];
int g_worst_energy[TOTAL_SEQUENCES];

/* Only energies <= g_energy_cutoff will be displayed. Probabilities have
 * a negative sign. For example, the value -30 indicates that only
 * probabilities >=.3 will be displayed.
 */
int g_energy_cutoff[TOTAL_SEQUENCES]; 

int g_count_no_offset; /* overlapping points for main window with  no offset */

double g_stack_energy[5][5][5][5]; /* for computing free energies of helices */

/* stored in positions 0 to
 * close_g_helices_used -1
 *                                       Positions
 *                        45  39  33  27  34  40  47
 *                        37  21  17  11  18  23  41
 *                        29  13   5   3   7  15  31
 *                        25   9   1   0   2  10  26
 *                        30  14   6   4   8  16  32
 *                        38  22  19  12  20  24  42
 *                        46  44  35  28  36  43  48
 * position 0 is the original position
 * positions 1 to 8 are 1 away
 * positions 9 to 24 are 2 away
 * positions 25 to 48 are 3 away
 * 0 is position of yellow, other numbers are position of green 
 */

struct basepair *g_nearby_basepair;

struct helix g_saved_helix[MAXIMUM_HELICES];
int  g_used_saved_helix;
int  g_saved_helix_start[2*MAXIMUM_SIZE+1]; /* Diagonal start positions */
int  g_saved_helix_count[2*MAXIMUM_SIZE+1];
int *g_neighbor_keeper_row;
int *g_neighbor_keeper_column;

struct helix g_diag[MAXIMUM_HELICES]; /* stores helices and overlaps */

int g_helices_used; /* stored in positions 0 to g_helices_used -1 */
int g_helices_used_temp_helix; /* how many helices in structure */

/* Used to store helices after they are split.
 * Helices are sorted and then copied to g_diagonal_row, col, energy, etc */

/* given a row and column add values to move to postion zero */
int g_hor_offset[49] = {
  0,  1, -1,  0,  0,  1, 1, -1, -1,  2, -2, 0,  0,  2,  2, -2, -2, 1, -1, 
  1, -1,  2,  2, -2, -2, 3, -3,  0,  0,  3, 3, -3, -3,  1, -1,  1, -1, 3,
  3,  2, -2, -3, -3, -2, 2,  3,  3, -3, -3
}; 

int g_ver_offset[49] = {
  0,  0, 0,  1, -1,  1, -1,  1, -1,  0,  0,  2, -2,  1, -1, 
  1, -1, 2,  2, -2, -2,  2, -2,  2, -2,  0,  0,  3, -3,  1, -1,
  1, -1, 3,  3, -3, -3,  2, -2,  3,  3,  2, -2, -3, -3,  3, -3, 3, -3
};

/* To compute diagonal k used diagonal k + offset below */

int close_g_diag_offset[49] = {
  0, -1,  1, -1, 1, -2,  0,  0,  2, -2, 2, -2, 2, -3, -1, 1, 
  3, -3, -1,  1, 3, -4,  0,  0,  4, -3, 3, -3, 3, -4, -2, 2, 
  4, -4, -2,  2, 4, -5, -1, -5, -1,  1, 5,  5, 1, -6,  0, 0, 6
};

int g_best_position_zoom = 0; /* for g_this_sequence */


/* Conversion Routines to display integers and floats */
char g_str[30];
char *num_string_int(int x) { /* converts integer to string */
  sprintf(g_str,"%d",x);
  return g_str;
}

char *num_string_int2(int x) { /* converts integer to string */
char junk[10];
 if(x==0)
   strcpy(g_str,"00");
 else { 
   sprintf(g_str,"%d",x);
   if((x>0) && (x<10)) {
     strcpy(junk,"0");
     strcat(junk,g_str);
     strcpy(g_str,junk);
   }
 }       
 return g_str;
}

char *num_string_double(double x) { /* converts integer to string */
  sprintf(g_str,"%.1f",x);
  return g_str;
}

char *num_prob_string(int x) { 
  float x_float;
  x_float = (float) x;
  x_float = -x_float/10000.;
  sprintf(g_str,"%5.4f",x_float);
  return g_str;
} 

char *num_energy_string(int x) { /* divide by 10 and convert to string */
  float x_float;
  x_float = (float)x;
  x_float = x_float/10.;
  /* round to hundredth position */
  if(x_float!=0.)
    sprintf(g_str,"%7.1f",x_float);
  else
    strcpy(g_str,"Undef.");
  return g_str;
}

/* Converts integer to string. Handles prob or energies */
char *num_string_fancy_int(int x) {
  float float_x;
  float_x=(float)x;
  if(g_prob==TRUE)
    return strcpy(g_str,num_prob_string(float_x));
  else
    return strcpy(g_str,num_energy_string(float_x));
}

char *num_string_fancy_float(float x) { /* float to string */
  if(g_prob==TRUE)
    return strcpy(g_str,num_prob_string(x));
  else
    return strcpy(g_str, num_energy_string(x));
}

/*__________________________tick mark functions ___________________*/

int step_fun(int dis_l, int dis_r) {
  int step;
  step = (dis_r - dis_l + 1)/8; /* make 8 steps  (9 tick marks total) */
  if(step<40) {
    if(step<3)
      step = 2;
    else if(step>5) {
      step = (step + 5)/10; /* make a large step a multiple of ten */
      step = step*10;
    } else
      if(step==4) /* make steps of 4 look like 5 */
	step=5;
  } else if(step>90) {
    step=(step+50)/100; /* round to nearest 100 */
    step = step*100;
  } else {
    step = (step + 25)/50; /* round to nearest 50 */
    step = step*50;
  }
  return step;
}

/* Make the tick marks start at a nice place. The ends are treated
 * separately and always drawn 
 */ 

int start_fun(int dis_l,int step) {
  int start;
  start = dis_l + step;
  if(step > 90) {
    start = (start + 60)/100; /* start at a multiple of 100 */
    start = start*100;
  } else if (step >= 40) {
    start = (start + 32)/50; /* start at a multiple of 50 */
    start = start*50;
  } else if (step > 5) {
    start = (start + 5)/10; /* start at a multiple of ten */
    start = start*10;
  }
  return start;
}

int check_compensate_char(char c1,char c2,char nc1,char nc2) {
  /* return TRUE when a compensating base pair is found */
  nc1 = toupper(nc1);
  nc2 = toupper(nc2);
  if(nc1=='T')
    nc1='U';
  if(nc2=='T')
    nc2='U'; 
  /* Start with AU */
  if((c1==nc1)||(c2==nc2))
    return FALSE;
  else  { /* watch out for undefined characters like X or N */
    if( ( (c1=='A') || (c1=='C') || (c1=='G') || (c1=='U') ) &&
	( (c2=='A') || (c2=='C') || (c2=='G') || (c2=='U') ) )
      return TRUE;
    else
      return FALSE;
  }
}

char position_reverser(int sequence,int pos) {
  return g_sequence_data[sequence][pos-1]; 
}

int check_compensate_real(int row,int col) {
  int i,j;
  int first_shifted_row,first_shifted_col;
  int shifted_row,shifted_col;
  char char1,char2;
  char new_char1,new_char2;
  /* Return true if compensating base pair occurs. Test this location
   * by compairing every sequence to every other sequence 
   */
  if(g_adjust_count_sequences==1)
    return FALSE;
  for(j=2;j<=(g_adjust_count_sequences);j++) {
    first_shifted_row = row;
    first_shifted_col = col;       
    char1 = position_reverser(j,first_shifted_row);
    char2 = position_reverser(j,first_shifted_col);
    char1 = toupper(char1);
    char2 = toupper(char2);
    if(char1=='T')
      char1='U';
    if(char2=='T')
      char2='U';
    for(i=j+1;i<=g_adjust_last_used_sequence;i++) {
      shifted_row=row;
      shifted_col=col;
      new_char1=position_reverser(i,shifted_row);
      new_char2=position_reverser(i,shifted_col);
      if(check_compensate_char(char1,char2,new_char1,new_char2)) {
	return TRUE;
      }
    }
  }
  return FALSE;
}

int check_compensate(int row,int col) {
  return check_compensate_real(row,col);
}

void fix_cursor(void);

int open_fancy_align(void) {
  if ((align_fp = fopen(fancy_align_filename, "wb")) == NULL) {
    printf ("Could not open file: %s\n", fancy_align_filename);
    return(1);
  }
  return (0);
}

int energy_read(int row,int col,int seq) { /*based on alignment coordinates */
  int diag,diag_start,diag_end,i,temp_row;
  if(col<row)
    return energy_read(col,row,seq);
  diag = col + row - 1;
  diag_start = g_diag_start[diag];
  diag_end = g_diag_start[diag+1];
  for(i=diag_start;i<diag_end;i++) {
    temp_row = g_diag[i].row;
    if(temp_row>row) 
      return 0;   /*  entries in diagonal are sorted */
    if(g_diag[i].color==seq) 
      if( (temp_row<=row) && (g_diag[i].row+g_diag[i].length-1>=row) )
	return g_diag[i].energy;
  }
  return 0;
} 
/* return index of helix containing this base pair based on alignment
   coordinates */ 
int index_energy_read(int row,int col,int seq) {
  int diag,diag_start,diag_end,i,temp_row;
  if(col<row)
    return index_energy_read(col,row,seq);
  diag = col + row - 1;
  diag_start = g_diag_start[diag];
  diag_end = g_diag_start[diag+1];
  for(i=diag_start;i<diag_end;i++) {
    temp_row=g_diag[i].row;
    if(temp_row>row) 
      return -1;   /*  entries in diagonal are sorted */
    if(g_diag[i].color==seq) 
      if( (temp_row<=row) && (g_diag[i].row + g_diag[i].length - 1 >= row) )
	return i;
  }
  return -1;
} 

void get_count(void) { /* Determine the number of sequences */
  char string[10];
  int length;
  g_count_sequences = 0;
  printf("1. Enter the number (0 to 5) of sequences, 0 exits.\n");
  printf("How Many Sequences?\t");
  fgets(string, 10, stdin); 
  length = strlen(string);
  string[length-1] = '\0';
  sscanf(string,"%d", &g_count_sequences);
  if(g_count_sequences<1) {
    try_exit(0);
  } else if(g_count_sequences > 5) {
    printf("Too many sequences\n");
    try_exit(3);
  }
  g_last_used_sequence=g_count_sequences+1;
}

void get_filename(void) {
  int length;
  fgets(filename, 80, stdin); 
  length = strlen(filename);
  filename[length-1] = '\0';
  printf("%d %s\n",length,filename);
  if (filename[0]=='/') {
    try_exit(0);
  }
}

int plot_or_ct_get_filename(char *name) { /* return TRUE for ct file suffix */
  int i;
  char input_name[120];
  input_name[0] = '\0';
  printf("Enter file name ? (/ to quit)\t");
  fgets(input_name, 80, stdin); 
  i = strlen(input_name);
  input_name[i - 1] = '\0';
  if(input_name[0]=='/') {
    try_exit(0);
  }
  if(strlen(input_name) == 0) 
    strcpy(input_name, name);
  i = strlen(input_name);
  if (!strcmp(input_name + i - 3, ".ct")) {
      strcpy(filename, input_name);
      return TRUE;
    } else {
      chop_suffix(input_name, ".plot"); /* strip off .plot if it is there */
      strcat(input_name,".plot");
      strcpy(filename, input_name); 
      return FALSE; 
  }
}

void read_sequence_name(int *contains_fasta, int seq, char *last_record) {
  char rec[120],name[120];
  int j;
  if(*contains_fasta) {
    strcpy(rec,last_record);
  } else if(fgets(rec,90,file)==NULL) {
    printf("Error!\tInsufficient data in file\n");
    try_exit(4);
  }
  while(rec[0]==';') {
    if(fgets(rec,90,file)==NULL) {
      printf("Insufficient data in file\n");
      try_exit(5);
    }
  }
  for(j=0;j<30;j++) {
    if(rec[j]=='\n')
      name[j]='\0';
    else
      name[j]=rec[j];
  }
  name[30] = '\0'; 
  if(name[0]=='>') {
    *contains_fasta = TRUE;
    for(j=1;j<=30;j++) {
      name[j-1] = name[j];
    }
  } 
  /* remove extra space */
  j = 1;
  while( (name[j]!=' ') && (name[j]!='\0') ) {
    j++;
  }
  name[j]='\0';
  strcpy(g_sequence_name[seq],name);
}

/* copy record into general sequence from position onward, return next
 * availiable position = length */ 
int copy_rec(int position, char *rec) { 
  int i;
  char c;
  i = 0;
  while( (rec[i]!='\0')) {
    if(!isspace(rec[i])) {
      if(rec[i]=='-')
	rec[i]='.';
      c=rec[i];
      c=toupper(c);
      if( (c!='A')&&
	  (c!='C')&&
	  (c!='G')&&
	  (c!='U')&&
	  (c!='T')&&
	  (c!='1')&&
	  (c!='.')) {
	printf("\tWarning!\tposition %d has a strange ",position+1);
	printf("character: %c\a\a\a\a\a\n",rec[i]);
      }   
      general_sequence[position]=rec[i]; /* nonnumeric non space
					  * characters are copied */ 
      position++;
      i++;
    } else
      i++;
  }
  return position;
}

int read_sequence(void) {
  char rec[90];
  int new_position;
  if(fgets(rec,90,file)==NULL) {
    printf("Insufficient data in file\n");
    try_exit(6);
  }
  new_position = 0;
  new_position=copy_rec(new_position,rec);
  general_sequence[new_position]='\0';
  while(general_sequence[new_position-1]!='1') {
    if(fgets(rec,90,file)==NULL) {
      printf("Insufficient data in file\n");
      try_exit(7);
    } 
    new_position=copy_rec(new_position,rec);
    if(new_position> (.97*MAXIMUM_SIZE)) {
      printf("Error!\tThe sequence size is too large.\n");
      printf("Adjust MAXIMUM_SIZE in %s.h ", PROGRAM_NAME);
      printf("to be at least 1.05 * the alignment length and recompile.\n");
      printf("Currently, the program only accepts lengths < %.1f\n",
	     (MAXIMUM_SIZE*.97));
      try_exit(8);
    }
  }
  general_sequence[new_position-1]='\0';
  return new_position-1;
}

int read_sequence_fasta(char *last_record) {
  int new_position;
  new_position=0;
  last_record[0]=' ';
  while((fgets(last_record,90,file)!=NULL)&&(last_record[0]!='>')) {
    new_position=copy_rec(new_position,last_record);
  }
  general_sequence[new_position]='\0';
  return new_position;
}

int check_same_base(int i) {
  char c,c2;
  int sequence;
  c = g_sequence_data[2][i];
  if(c=='T')
    c='U';
  for(sequence=3;sequence<=g_last_used_sequence;sequence++) {
    c2=g_sequence_data[sequence][i];
    if(c2=='T')
      c2='U';
    if(c!=c2)
      return FALSE;
  }
  return TRUE;
}

void set_sequence_data_same(void) {
  /* check if this position has the same base in all sequences 
   * notices sequence data starts at zero, same data starts at 1
   * Thus same matches row,col values */
 int i,black;
 for(i=1;i<=g_sequence_length;i++) { 
   black=check_same_base(i-1);
   g_sequence_data_same[i]=black;
 }
} 

void set_translator(int seq) {
  /* goes from small numbering to large one */
  int alpha_count,j;
  char *string;
  string=(char *)malloc((g_sequence_length+5)*sizeof(char));
  if(string==NULL) {
    printf("Error in allocating string from set_translator\n");
    try_exit(9);
  }
  alpha_count=0;
  strcpy(string,g_sequence_data[seq]);
  for(j=0;j<g_sequence_length;j++) {
    if(isalpha(string[j])) {
      alpha_count++;
      g_sequence_translator[seq][alpha_count]=j+1;
    }
  }
  g_nucleotide_total[seq]=alpha_count;
  if(g_first_run) 
    printf("Length of sequence: %s is %d without insertions\n",
	   g_sequence_name[seq],alpha_count);
  free(string);
}

void set_reverse_translator(int seq) {
  int i;
  /* goes from large numbers back to smaller ones
   * g_reverse_st[seq][j] returns where position j of the new sequence 
   * was in the original sequence for sequence seq (2-6)
   * set to 0 for not defined 
   */
  for(i=0;i<=g_sequence_length;i++)
    g_reverse_st[seq][i]=0;
  /* set to non-zero for defined ones */
  for(i=1;i<=g_nucleotide_total[seq];i++)
    g_reverse_st[seq][g_sequence_translator[seq][i]]=i;
}


void set_helix_use(int sequence) {
  int i;
  g_sequence_helix_used[sequence]=
    (int *)malloc((g_nucleotide_total[sequence]+1)*sizeof(int));
  printf("Initializing helix data for sequence %d\n",sequence-1);
  printf("Length is %d\n",g_nucleotide_total[sequence]);
  if(g_sequence_helix_used[sequence]==NULL) {
    printf("Error!\tInsufficient memory for helix data\n");
    try_exit(10);       
  }
  g_sequence_helix_used_length[sequence]=0;
  for(i=1;i<=g_nucleotide_total[sequence];i++)
    g_sequence_helix_used[sequence][i]=FALSE;
}

void get_alignment_first(void) {
  int i,length;
  int tries;
  int contains_fasta;
  char last_record[120];
  contains_fasta=FALSE;
  tries=1;
  /*  open file */
  printf("2.  Enter the alignment file name:\t");
  get_filename(); /* Get name and open file */
  strcpy(g_in_align_filename,filename);
  while(((file=fopen(filename,"r"))==NULL)&&(tries<10)) {
    printf("\aWarning!\tCould not open file: %s\n",filename);
    get_filename();
    tries++;
  }
  if(tries==10) {
      printf("Error!\tI give up!\t Too many tries.\n");
      printf("Try running the program again for the alignment file\n");
      try_exit(11);
  }
   for(i=2;i<=g_last_used_sequence;i++) {
     printf("Searching for name and data for sequence %d\n",i-1);
     read_sequence_name(&contains_fasta,i,last_record);
     if(contains_fasta) {
       if(i==2)
	 printf("fasta format detected\n");
       length=read_sequence_fasta(last_record);
     } else {
       length=read_sequence();
       if(i==2)
	 printf("Stanford IG format detected\n");
     }
     /* 3 below is needed for insertions due to shifting */
     g_sequence_data[i]=(char *)malloc(3*(length+1)*sizeof(char));
     g_sequence_data_new[i]=(char *)malloc(3*(length+1)*sizeof(char));
     g_sequence_data_previous[i]=
       (char *)malloc(3*(length+1)*sizeof(char));
     g_sequence_data_previous2[i]=
       (char *)malloc(3*(length+1)*sizeof(char));
     g_sequence_data_original[i]=
       (char *)malloc(1.1*(length+1)*sizeof(char));
     g_sequence_data_saved[i]=
       (char *)malloc(3.0*(length+1)*sizeof(char));
     if((g_sequence_data[i]==NULL)|| (g_sequence_data_new[i]==NULL)||
	(g_sequence_data_previous2[i]==NULL)|| 
	(g_sequence_data_previous[i]==NULL)||
	(g_sequence_data_original[i]==NULL)||
	(g_sequence_data_saved[i]==NULL)) {
       printf("Error!\tInsufficient memory for sequence data\n");
       try_exit(12);       
     }   
     strcpy(g_sequence_data[i],general_sequence);
     if(g_first_run) {
       strcpy(g_sequence_data_previous2[i],general_sequence);
       strcpy(g_sequence_data_previous[i],general_sequence);
       strcpy(g_sequence_data_original[i],general_sequence);
       strcpy(g_sequence_data_saved[i],general_sequence);
     }
     if(i==2) {
       g_sequence_length=length;
       g_last_diagonal=2*length-1;
       g_sequence_length_previous=length;
       g_sequence_length_previous2=length;
       g_sequence_length_original=length;
         g_sequence_length_saved=length;
     } else if(g_sequence_length!=length) {
       printf("Warning!\tlengths of sequence are not equal.");
       printf("Please use proper data files.\n");
       printf("Length is %d with insertions.",length);
       printf("Length of first was %d with insertions.\n", g_sequence_length);
       try_exit(13);
     }
     if(length==0) {
       printf("Error in data (zero length)\n");
       try_exit(14);
     }
     set_translator(i);
     set_reverse_translator(i);
     set_helix_use(i);  
   }
   fclose(file);
   g_sequence_data_same= (int *)malloc((g_sequence_length+2)*sizeof(int));
   if(g_sequence_data_same==NULL) {
     printf(" Error allocating memory for g_sequence_data_same\n");
     try_exit(15);
   }
   set_sequence_data_same();
}

void get_alignment_main(void) {
  int i;
  g_sequence_length = g_new_length;
  g_last_diagonal = 2*g_sequence_length - 1; /* fix September 22 */
   for(i=2; i<=g_last_used_sequence; i++) {
     strcpy(g_sequence_data[i],g_sequence_data_new[i]);
     set_translator(i);
     set_reverse_translator(i); 
   }
   free(g_sequence_data_same); 
   g_sequence_data_same=
     (int *) malloc((g_sequence_length+2) * sizeof(int));
   if(g_sequence_data_same==NULL) {
     printf("Error allocating memory for g_sequence_data_same\n");
     try_exit(16);
   }
   set_sequence_data_same();
}

void open_plot_file(int seq) {
  int len_without_plot;
  int tries;
  tries=1;
  if(g_first_run) {
      printf("3. Enter file name for plot or ct file for: %s\n",
	     g_sequence_name[seq]);
    printf("ct files require .ct extension\n");
    printf(" / to quit, for no file use none, Default is %s.plot\n",
	   g_sequence_name[seq]); 
  }
  if(g_first_run)
    g_file_is_ct[seq]=plot_or_ct_get_filename(g_sequence_name[seq]);
  else
    strcpy(filename,plot_filename[seq]);
  if(strcmp(filename,"none.plot"))
     g_file_is_skipped[seq]=FALSE;
  else
     g_file_is_skipped[seq]=TRUE;
   while((g_file_is_skipped[seq]!=TRUE)&&(tries<10)&&
           ((file=fopen(filename,"r"))==NULL)) {
      printf("\aWarning!\tCould not open file: %s\n",filename);
      g_file_is_ct[seq]=plot_or_ct_get_filename(g_sequence_name[seq]);
      if(strcmp(filename,"none.plot"))
	g_file_is_skipped[seq]=FALSE;
      else
        g_file_is_skipped[seq]=TRUE;
      tries++;
   }
   if( tries == 10 ) {
     printf("Error!\tRerun with an existing plot or ct file.\n");
     try_exit(17);
   }
   strcpy(plot_filename[seq],filename);
   /* the code below copies the filename to short without the .plot */
   if(g_file_is_ct[seq])
     len_without_plot=strlen(plot_filename[seq])-3;
   else
     len_without_plot=strlen(plot_filename[seq])-5;
   strcpy(plot_filename_short[seq],plot_filename[seq]);
   plot_filename_short[seq][len_without_plot]='\0';
   printf("Filename: %s\n",plot_filename[seq]); 
}

/* put append this entry of the file into the next position in g_diag */

void insert(int row,int col,int length,float rec_energy,int seq) {
  int diag;
  diag=row+col-1;
  g_diag[g_helices_used].row=row;
  g_diag[g_helices_used].column=col;
  g_diag[g_helices_used].diagonal=diag;
  g_diag[g_helices_used].color=seq;
  g_diag[g_helices_used].energy=rec_energy;
  g_diag[g_helices_used].length=length;
  g_diag_count[diag]++;
  g_helices_used++;
  return;  
}

/* place helix from plot or ct file into next position of g_saved_helix */

void saved_append(int length,int row,int col,float rec_energy,int seq) {
  int diag;
  diag = row + col - 1;
  g_saved_helix[g_used_saved_helix].row = row;
  g_saved_helix[g_used_saved_helix].column = col;
  g_saved_helix[g_used_saved_helix].diagonal = diag;
  g_saved_helix[g_used_saved_helix].color = seq;
  g_saved_helix[g_used_saved_helix].length = length;
  g_saved_helix_count[diag] = g_saved_helix_count[diag]+1;
  if(g_prob)
    rec_energy = -10000.0*rec_energy;
  g_saved_helix[g_used_saved_helix].energy = rec_energy;
  g_used_saved_helix++;
}

/* given a helix, either insert it into list or split it, insert first part 
 * and call split_insert again on the rest of it */
void split_insert(int length, int row, int col, int rec_energy, int seq) {
  int new_start_col,new_start_row,new_end_row,new_end_col;
  int partial_length;
  int fst_helix_end_col,fst_helix_end_row,snd_helix_start_col;
  int snd_helix_start_row,new_start_found;
  new_start_row=g_sequence_translator[seq][row];
  new_start_col=g_sequence_translator[seq][col];
  if(col>g_nucleotide_total[seq]) {
    printf("Column number %d from plot file is > sequence length, %d\n",
	   col,g_nucleotide_total[seq]);
    printf("Column %d, row %d, energy was %d, partial length = %d\n",
	   col,row,rec_energy,length);
    printf("Bad sequence was %d (%s)\n",seq-1,g_sequence_data[seq]);
    try_exit(18);
  }
  new_end_row=g_sequence_translator[seq][row+length-1];
  new_end_col=g_sequence_translator[seq][col-length+1];
  if(((new_end_row-new_start_row+1)==length)&&
     ((new_start_col-new_end_col+1)==length))
    insert(new_start_row,new_start_col,length,rec_energy,seq);
  else {   /* find end of first helix */
    partial_length=1;
    new_start_found=FALSE;
    while(new_start_found==FALSE) {
      if(partial_length>600) {
	printf("Catastrophic error in %s!\n", PROGRAM_NAME);
	printf("helix length is %d, partial length is %d\n",
	       length, partial_length);
	printf("row is %d col is %d energy is %d\n",  row,col,rec_energy);
	printf("new_start_row is %d new_start_col is %d\n",
	       new_start_row, new_start_col);
	try_exit(19);
      }
      fst_helix_end_row = g_sequence_translator[seq][row+partial_length-1];
      fst_helix_end_col = g_sequence_translator[seq][col-partial_length+1];
      snd_helix_start_row = g_sequence_translator[seq][row+partial_length];
      snd_helix_start_col = g_sequence_translator[seq][col-partial_length];
      if(((snd_helix_start_row-fst_helix_end_row)>1)||
	 ((fst_helix_end_col-snd_helix_start_col)>1))
	new_start_found=TRUE;
      else
	partial_length++;
    }
    insert(new_start_row,new_start_col,partial_length,rec_energy,seq);
    /* insert the first part of helix */
    split_insert(length-partial_length,row+partial_length,
		 col-partial_length,rec_energy,seq);
    /* call split_insert with rest of helix */
  }
}

float process_line_of_plot_file(char rec[90],int seq) {
  /* break each line of file into component pieces
   * returns energy for optimal and worst comparison */
  int level,length,row,col;
  float rec_energy;
  sscanf(rec,"%d%d%d%d%f",&level,&length,&row,&col,&rec_energy);
  if((rec_energy<0)||(rec_energy>3))
    g_prob=FALSE;
  saved_append(length,row,col,rec_energy,seq);
  return rec_energy;
}

void translate_plot_file(int seq) {
  char rec[90];
  float energy;
  float biggest_energy = 0.0, smallest_energy = 0.0;
  if(fgets(rec,90,file)==NULL) {
    printf("\aError!\tNo data in plot file %s\n",filename);
    try_exit(20);
  }
  if(fgets(rec,90,file)!=NULL) {
    energy = process_line_of_plot_file(rec,seq);
    biggest_energy = energy;
    smallest_energy = biggest_energy;
  }
 while(fgets(rec,90,file)!=NULL) {
   energy=process_line_of_plot_file(rec,seq);
   if(energy<smallest_energy)
     smallest_energy=energy;
   if(energy>biggest_energy)
     biggest_energy=energy;
 }
 if(g_prob!=TRUE) {
   g_optimal_energy[seq]=(int)(smallest_energy);
   g_worst_energy[seq]=(int)(biggest_energy);
 } else {
   g_optimal_energy[seq]=(int)(-10000*(biggest_energy)-.5);
   g_worst_energy[seq]=(int)(-10000*(smallest_energy)-.5);
 }     
 /* read and process lines of plot file */
}

void translate_ct_file(int,char *);

void get_plot_files(void) {
  int i;
  /* int diag; */
  for(i=2;i<=g_last_used_sequence;i++) {
    open_plot_file(i);
    if(!g_file_is_skipped[i]) {
      if(g_file_is_ct[i]) {
	translate_ct_file(i,plot_filename[i]);
	printf("Processing ct file . . . .\n");
      } else {
	translate_plot_file(i); 
	printf("Processing plot file . . . .\n");
      }
      fclose(file);
    }
    else {
      g_worst_energy[i]=0;
      g_optimal_energy[i]=0;
    } 
  }
  /* finished reading helices, now get ready to sort
   * now plot files have been combined into one and sorted
   * read them back in again. */
  g_worst_energy[0]=99999;
  g_worst_energy[1]=999999; /* The cutoff will be set to worst. Thus
			     * all helices are shown */ 
  g_diag_start[1]=0;
  for(i=2;i<=(g_sequence_length*2-1);i++) {
    g_diag_start[i]=g_diag_start[i-1]+g_diag_count[i-1];
  }
}

void initialize_first_initialize(void) {
/* initializes worst and optimal energy for each sets number of
 * helices in each diagonal to zero sets name of overlap or partial
 * overlap */ 
  int i;
  for(i=1;i<=(g_sequence_length*2-1);i++)
    g_saved_helix_count[i]=0;
  strcpy(g_sequence_name[0],"All");
  if(g_count_sequences>2)
    strcpy(g_sequence_name[1],"Partial Intersect");
  else
    strcpy(g_sequence_name[1],"  ");
  g_prob=TRUE;
  g_best_position_zoom=0;
}

void display_start_counts(void) {
  /* display where each diagonal starts and how many in each */ 
  int i;
  for(i=1;i<=g_last_diagonal;i++) {
    printf("Diagonal %d starts at %d and contains %d.\n",i,
	   g_diag_start[i],g_diag_count[i]);
  }
} 

void display_contents(void) {
  int i;
  for(i=0;i<g_helices_used;i++) {
    printf("helix=%d,diag=%d, row=%d, col=%d, length=%d\n",
	   i,g_diag[i].column+g_diag[i].row-1,
	   g_diag[i].row,g_diag[i].column,g_diag[i].length);
    printf("seq=%d, energy=%d\n",g_diag[i].color,g_diag[i].energy);
  }
}
 
/* sequence 2 is the first sequence
 * sequence 3 is the second sequence
 * sequence 0 is the overlap of all sequences 
 * sequence 1 is the partial overlap 
 */

/* Find Overlapping helices ___________________________________________*/


int create_new_helices(int diag,int nearest_position, int farthest_position,
		       int long_array[MAXIMUM_SIZE+1]) {
  int start_row = 0, search_position,new_length = 0;
  int start_found;
  int overlapping_points;
  overlapping_points=0;
  /* search for partial intersection */
 if(g_adjust_last_used_sequence>3) {
   search_position=nearest_position-1;
   start_found=FALSE;
   while(search_position<=farthest_position+1) { /* +1 guarantees the
						  end is found */ 
     search_position++;
     if(start_found==FALSE) { /* looking for start of helix */
       if((long_array[search_position]<g_count_sequences)
	  &&(long_array[search_position]>1)) {
	 start_found=TRUE;
	 start_row=search_position;
	 new_length=1;
       }
     } else {      /* looking for end of helix */
       if((long_array[search_position] <  g_adjust_count_sequences)&&
	  (long_array[search_position]>1))
	 new_length++;
       else {
	 start_found=FALSE;
	 insert(start_row,diag+1-start_row, new_length,SMALLEST_ENERGY,1);
       }
     }
   }
 } 
 /* find full intersection */
 search_position=nearest_position-1;
 start_found=FALSE;
 while(search_position<=farthest_position+1) { /* +1 guarantees the end
						is found */ 
   search_position++;
   if(start_found==FALSE) { /* looking for start of helix */
     if(long_array[search_position]==(g_adjust_last_used_sequence-1)) {
       start_found=TRUE;
       start_row=search_position;
       new_length=1;
     }
   } else {      /* looking for end of helix */
     if(long_array[search_position]==(g_adjust_last_used_sequence-1))
       new_length++;
     else {
       start_found=FALSE;
       insert(start_row,diag+1-start_row, new_length,SMALLEST_ENERGY,0);
       overlapping_points=overlapping_points+new_length;
     }
   }
 } 
 return overlapping_points;
}

/* diag = row + col - 1
 * this can be used to compute column any time
 * returns the number of overlapping points along this diagonal */

int find_overlap_diag(int diag, int long_array[MAXIMUM_SIZE+1]) {
  /* assumes diagonals are sorted by row within the list
   * assume long_array contains zeros to start
   * plot values from diagonal in long_array 
   */
  int helices,row,length;
  int i;
  int count;
  int temp_farthest_position,position;
  int overlapping_points;
  int farthest_position; /* save to zero out only used positions */
  int nearest_position;
  nearest_position=2*g_sequence_length;
  farthest_position=0;
  count=g_diag_count[diag];
  if(count==0)
    return 0;
  /* Fill in array assuming that coordinates in the dot plot
     occur at most one time for each sequence */
  for(helices=0;helices<count;helices++) { /* go through loop for each helix */
    position=g_diag_start[diag]+helices;
    length=g_diag[position].length;
    row=g_diag[position].row;
    if(g_diag[position].color<=g_adjust_last_used_sequence) {
      temp_farthest_position=row+length-1;
      if(nearest_position>row)
	nearest_position=row;
      if(temp_farthest_position>farthest_position)
	farthest_position=temp_farthest_position;
      for(i=row;i<=(temp_farthest_position);i++)
	long_array[i]=long_array[i]+1;
    }
  }
  /* create new helices */
  overlapping_points = 
    create_new_helices(diag, nearest_position, farthest_position, long_array);
  for(i=nearest_position;i<=farthest_position;i++)
    long_array[i]=0;
  return overlapping_points;
}

/* find uses data from each diagonal to create a new diagonal
 * any position along the diagonal that is hit twice is recorded
 * helices are produced and recorded as sequence 6 in the global
 * diagonal arrays
 * returns the number of overlapping points 
 */
int find_overlap(void) {
  int i;
  /* zero out the array */
  int overlap_points;
  int *long_array;
  long_array=(int *)malloc(sizeof(int)*g_sequence_length*1.5+10);
  if(long_array==NULL) {
    printf("Error!\tInsufficient memory to allocate long array");
    try_exit(21);
  }
  overlap_points=0;
  for(i=1;i<=(g_sequence_length*1.5+1);i++)
       long_array[i]=0;
  for(i=2;i<=g_last_diagonal;i++)
    overlap_points=overlap_points+find_overlap_diag(i,long_array);
  free(long_array);
   return overlap_points;
}


/* sorting helices _________________________________________________*/
int compare_helices(const void *h1,const void *h2) {
  int dif;
  struct helix *helix1,*helix2;
  helix1=(struct helix *)h1;
  helix2=(struct helix *)h2; 
  dif=(*helix1).diagonal-(*helix2).diagonal; /* return <0 if diag1 < diag2 */
  if(dif==0) /* on same diagonal */
    dif=(*helix1).row-(*helix2).row; /* return <0 if row1<row2 or >0 if > */
  return dif;
}     

/* This function should sort helices on a diagonal
 * It should sort them increasing order by row within coloumn*/
void sort_helices(void) {
  qsort(g_diag,g_helices_used,
	sizeof(struct helix),compare_helices);
}

void sort_helices_saved(void) {
  qsort(g_saved_helix,g_used_saved_helix,
	sizeof(struct helix),compare_helices);
}
    
/* functions for making common files */


/* given a row column and sequence it returns the length of the helix
 * within the helix from row,column to its end */

int tail_read(int row,int col,int seq) {
  int diag,diag_start,diag_end,i,temp_row;
  diag=col+row-1;
  diag_start=g_diag_start[diag];
  diag_end=g_diag_start[diag+1];
  for(i=diag_start;i<diag_end;i++) {
    temp_row=g_diag[i].row;
    if(temp_row>row) 
      return 0;   /*  entries in diagonal are sorted */
    if(g_diag[i].color==seq) 
      if( (temp_row<=row) && ((g_diag[i].row+g_diag[i].length-1)>=row) )
	return (g_diag[i].length-(row-temp_row));
  }
  return 0;
} 

/* converts helices from the intersection to the corresponding helices in
 * sequence
 * the corresponding line of the plot file is then written
 * notice some sililarity to plot_my_points_zoom */

int check_compensate(int,int);

void common_print_helix(int dump_l, int dump_r, int dump_t, int dump_b, 
			int seq, int col_start, int row_start, int length,
                        int comp_flag, int type_of_dump) {
  int part_length, energy, row_start_old, col_start_old;
  int right_amount, above_amount, below_amount, left_amount;
  int old_energy, new_length, i, comp_row, comp_col;
  if((row_start+length-1)<dump_t)
    return; /* helix is above region */
  if((col_start-length+1)>dump_r)
    return; /* sequence is right of region
	     * chop head of helix to right of region */
  right_amount=col_start-dump_r;
  if(right_amount>0) {
    length=length-right_amount;
    col_start=col_start-right_amount;
    row_start=row_start+right_amount;
  } 
   /* chop head of helix above region */
   above_amount=dump_t-row_start;
   if(above_amount>0) {
     length=length-above_amount;
     col_start=col_start-above_amount;
     row_start=row_start+above_amount;
   } 
   /* chop off tail of helix below region */
   below_amount=(row_start+length-1)-dump_b;
   if(below_amount>0)
      length=length-below_amount; 
   /* chop off tail of helix left of region */
   left_amount=(dump_l-(col_start-length+1));
   if(left_amount>0)
     length=length-left_amount; 
   part_length=tail_read(row_start,col_start,seq);
   if(part_length>length) /* intersection is smaller */
     part_length=length;
   if(part_length==0)
     printf("Error in common_print_helix 1\n");
   row_start_old=g_reverse_st[seq][row_start]; /* get original row */
   col_start_old=g_reverse_st[seq][col_start]; /* and column */
   if(type_of_dump!=PLOT) { /* do for forced file */
     for(i=1;i<=length;i++) {
       comp_row=row_start+i-1;
       comp_col=col_start-i+1;
       if((!comp_flag)||(check_compensate(comp_row,comp_col))) {
	 fprintf(com_plot_fp, "F %6d %6d %6d\n", row_start_old+i-1, 
		 col_start_old-i+1, 1);
       }    
     }
   } else {
     if(!comp_flag) {
       /* plot file , but not compensate */
       energy = energy_read(row_start, col_start, seq);
       old_energy = energy;
       new_length = 1;
       for(i=2; i<=length; i++) {
	 energy=energy_read(row_start + i - 1,col_start - i + 1,seq);
	 if(energy!=old_energy) {
	   fprintf(com_plot_fp,"      1 %6d %6d %6d %6d\n", new_length,
		   row_start_old, col_start_old, old_energy);
	   new_length = 1;
	   old_energy = energy;
	   row_start_old = row_start_old+i-1;
	   col_start_old = col_start_old-i+1;
         } else {
	   new_length++;         
	 }
       }
       fprintf(com_plot_fp,"      1 %6d %6d %6d %6d\n",new_length,
	       row_start_old,col_start_old,old_energy);
    } else { /* plot file and compensate */
       for(i=1;i<=length;i++) {
	 comp_row=row_start+i-1;
	 comp_col=col_start-i+1;
	 if(check_compensate(comp_row,comp_col)) {
	   energy=energy_read(comp_row,comp_col,seq);
	   fprintf(com_plot_fp,"      1      1 %6d %6d %6d\n",
		   row_start_old+i-1,col_start_old-i+1,energy);
	 }   
       }
     }    
   }
}         

void common_convert_helices(int dump_l, int dump_r, int dump_t, int dump_b,
			    int seq, int comp_flag, int type_of_dump_flag) {
  int diag,end_diag,start_diag;
  int position,location,count,temp_seq,col_start,row_start;
  int length;
  if(type_of_dump_flag==PLOT)
    fprintf(com_plot_fp,"\tlevel\tlength\tistart\tjstart\tenergy\n");
  start_diag = dump_l + dump_t - 1;
  end_diag = dump_r+dump_b-1;
  for(diag = start_diag;diag<=end_diag;diag++) {
    position = g_diag_start[diag];
    for(count=0;((count<g_diag_count[diag]) && 
		 (g_diag[position+count].row<=dump_b) ); count++) {
      location=position+count;
      temp_seq=g_diag[location].color;
      if(temp_seq==0) {
	col_start=g_diag[location].column;
	row_start=g_diag[location].row;
	length=g_diag[location].length;
	if((col_start>=dump_l)&&(row_start<=dump_b)) {
	  common_print_helix(dump_l,dump_r,dump_t,dump_b,seq,col_start,
			     row_start,length, comp_flag,type_of_dump_flag);
	}
      } 
    }
  } 
}

/* functions for close option and making common file */

/* converts helices from the intersection to the corresponding helices in
 * sequence
 * the corresponding line of the plot file is then written
 * notice some sililarity to plot_my_points_zoom 
 */

void close_common_print_helix(int dump_l, int dump_r,int dump_t,int dump_b,
			      int seq,int col_start,int row_start,int length) {
  int part_length,remaining_length,energy,best_energy;
  int row_start_old,col_start_old;
  int old_row,old_col;
  /* old_row and col are found be converting rows and columns
   * from close rows and columns to their original positions */
  int right_amount, above_amount, below_amount, left_amount;
  if((row_start+length-1)<dump_t)
    return; /* helix is above region */
  if((col_start-length+1)>dump_r)
    return; /* sequence is right of region
	     * chop head of helix to right of region */
  right_amount=col_start-dump_r;
  if(right_amount>0) {
    length=length-right_amount;
    col_start=col_start-right_amount;
    row_start=row_start+right_amount;
  } 
  /* chop head of helix above region */
  above_amount=dump_t-row_start;
  if(above_amount>0) {
    length=length-above_amount;
    col_start=col_start-above_amount;
    row_start=row_start+above_amount;
  } 
  /* chop off tail of helix below region */
  below_amount=(row_start+length-1)-dump_b;
  if(below_amount>0)
    length=length-below_amount; 
  /* chop of tail of helix left of region */
  left_amount=(dump_l-(col_start-length+1));
  if(left_amount>0)
    length=length-left_amount;
  old_row=row_start;
  old_col=col_start;
  energy=energy_read(old_row,old_col,seq);
  /* must print an energy */
  best_energy=energy;
  part_length=tail_read(old_row,old_col,seq);
  if(part_length>length) /* intersection is smaller */
    part_length=length;
  if(part_length==0)
    printf("Error in common_print_helix 3\n");
  remaining_length=length-part_length;
  row_start_old=g_reverse_st[seq][old_row]; /* get original row and column */
  col_start_old=g_reverse_st[seq][old_col]; 
  /* find the best energy within the merged helix */
  while(remaining_length>0) { /*The intersection is made of multiple helices */
    row_start=row_start+part_length; /* of seq */
    col_start=col_start-part_length;/* this considers the merge */
    old_row=row_start;
    old_col=col_start;
    energy=energy_read(old_row,old_col,seq);
    if(energy<best_energy)
      best_energy=energy;/* only print the best energy of the helix */
    part_length=tail_read(old_row,old_col,seq);
    if(part_length==0)
      printf("Error in common_print_helix 4\n");
    if(part_length>remaining_length)
      part_length=remaining_length;
    remaining_length=remaining_length-part_length;
  }
  if(g_prob!=TRUE)
    fprintf(com_plot_fp," %6d %6d %6d %6d %d\n",0,
	    length,row_start_old,col_start_old,best_energy);
  else
    fprintf(com_plot_fp," %6d %6d %6d %6d %.4f\n",0,
	    length,row_start_old,col_start_old,
	    ((float)best_energy)/-10000.);
}         


void create_align_file_sequence(int i,int new_length) {
  int complete_rows;
  int row,j,k,next_char;
  char piece[51];
  /* print complete rows */
  complete_rows=new_length/50;
  for(row=1;row<=complete_rows;row++) {
    for(j=1;j<=50;j++) {
      piece[j-1]=g_sequence_data[i][(row-1)*50+j-1];
    }
    piece[50]='\0';
    fprintf(afile,"%s\n",piece);
  }
  next_char=complete_rows*50;
  if(next_char<new_length) {
    /* print partial row */
    for(j=next_char,k=0;j<new_length;j++,k++) {
      piece[k]=g_sequence_data[i][j];
    }
    piece[k]='\0';
    fprintf(afile,"%s1\n",piece);
  } else
    fprintf(afile,"1\n");
}

void create_align_file_sequence_append(int i,int new_length) {
  int complete_rows;
  int row,j,k,next_char;
  char piece[51];
  /* print complete rows */
  complete_rows=new_length/50;
  for(row=1;row<=complete_rows;row++) {
    for(j=1;j<=50;j++) {
      piece[j-1]=g_sequence_data_new[i][(row-1)*50+j-1];
    }
    piece[50]='\0';
    fprintf(afile,"%s\n",piece);
  }
  next_char=complete_rows*50;
  if(next_char<new_length) {
    /* print partial row */
    for(j=next_char,k=0;j<new_length;j++,k++) {
      piece[k]=g_sequence_data_new[i][j];
    }
    piece[k]='\0';
    fprintf(afile,"%s1\n",piece);
  } else {
    fprintf(afile,"1\n");
  }
}

void display_time_mal(FILE *fp) {
  time_t now;
  now=time(NULL);
  fprintf(fp,"; %s",ctime(&now));
}

void create_align_file(int new_length,int NEW_FILE) {
  int i;
  char action[200];
  int error_occurred;
  if(NEW_FILE)
    strcpy(g_out_align_filename,fancy_align_filename); 
  else
    strcpy(g_out_align_filename,PROGRAM_NAME"_align.mal");
  if(NEW_FILE) {
    printf("Writing to alignment file %s\n",g_out_align_filename);
    if((afile=fopen(g_out_align_filename,"r"))!=NULL) {
      printf("Warning! %s exists. Creating backup file %s.bu\n",
	     g_out_align_filename,g_out_align_filename);
      strcpy(action,"mv ");
      strcat(action,g_out_align_filename);
      strcat(action," ");
      strcat(action,g_out_align_filename);
      strcat(action,".bu");
      error_occurred=system(action);
      if(error_occurred!=0) {
	printf("Error %d occurred making %s.bu\n", error_occurred,
	       g_out_align_filename);
      }
    }
    if((afile=fopen(g_out_align_filename,"w"))==NULL) {
      printf("\aError!\tCould not open align file %s\n",g_out_align_filename);
      return;
    }
  } else {
    printf("Appending to alignment file: %s\n",g_out_align_filename);
    if((afile=fopen(g_out_align_filename,"a"))==NULL) {
      printf("Error!\tCould not open align file %s\n",g_out_align_filename);
      return;
    }
  }
  fprintf(afile,";\n;\n");
  if(!NEW_FILE)
    fprintf(afile,";New alignment Starts Here ___________________________\n");
  display_time_mal(afile); 
  fprintf(afile,";\n;\n;\n");
 for(i=2;i<=g_last_used_sequence;i++) {
   for(i=2;i<=g_last_used_sequence;i++) { 
     fprintf(afile,";\n");
     fprintf(afile,"%s\n",g_sequence_name[i]);
     if(NEW_FILE)
       create_align_file_sequence(i,new_length);
     else
       create_align_file_sequence_append(i,new_length);   
   }
 }
 fclose(afile); 
}

int dot_found(int pos) {
  /* return true if all sequences have an insertion at this pos.*/
  int sequence;
  sequence=2;
  while(sequence<=g_last_used_sequence) {
    if(g_sequence_data_new[sequence][pos]!='.')
      return FALSE;
    sequence++;
  }
  return TRUE;
}

int remove_duplicates(int pos,int new_length) {
  int sequence,pos2;
 while(pos<=(new_length)) {
   if(dot_found(pos)) {
     printf("Removing double insertion at position %d\n",pos+1);
     for(pos2=pos;pos2<=(new_length);pos2++) {
       for(sequence=2;sequence<=g_last_used_sequence;sequence++)
         g_sequence_data_new[sequence][pos2] =
	   g_sequence_data_new[sequence][pos2+1];
     }
     new_length--;
     pos--;
   }
   pos++;   
 }
 return new_length;
}

void display_insert(int sequence,int num_insertions,int pos_old) {
  int true_pos;
  int pos;
  pos=pos_old;
  true_pos=0;
  while((pos<=g_sequence_length)&&(true_pos==0)) {
    true_pos=g_reverse_st[sequence][pos];
    pos++;
  }
  if(true_pos==0)
    printf("Made %d insertions just after end of %s, old was %d\n",
	   num_insertions,g_sequence_name[sequence],pos_old);
  else
    printf("Made %d inserts just before base %d of %s,old was %d\n",
           num_insertions,true_pos,g_sequence_name[sequence],pos_old);
}

int create_new_data(int jp,int j,int i,int ip ) {
  int new_length;
  int pos;
  int k2,nk2,nk1,k1;
  int count;
  int length_adjuster;
  int sequence;
  /* above are left,right,top,bottom
   * or jprime,j,i,iprime
   * returns length of sequence with insertions
   * first store previous in previous2 */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence],
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* second store old sequence in previous*/
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence], g_sequence_data[sequence]);
  }
  g_sequence_length_previous=g_sequence_length;
  new_length = g_sequence_length + abs(g_ver_offset[g_best_position_zoom]) +
    abs(g_hor_offset[g_best_position_zoom]);
  /* copy stuff over but start at position 1 */
 for(pos=0;pos<=g_sequence_length;pos++) {
   for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
     g_sequence_data_new[sequence][pos+1]=
       g_sequence_data[sequence][pos];
   }
  }
 g_sequence_data_new[2][0]=' ';
 /* new now contains old sequence */
 k2=g_hor_offset[g_best_position_zoom];
 k1=g_ver_offset[g_best_position_zoom]; 
 printf("IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII\n");
 printf("I                                      I\n");
 if(k2>0) {
   /* fix B or number 3  or g_this_sequence*/
   printf("Moving selected %s right %d\n",
	  g_sequence_name[g_this_sequence],k2);
   display_insert(g_this_sequence,k2,jp);
   /* start of my way */
   for(pos=(g_sequence_length+1);pos>=(jp);pos--) {
     g_sequence_data_new[g_this_sequence][pos+k2]=
       g_sequence_data_new[g_this_sequence][pos];
   }
   for(count=1;count<=k2;count++) {
     g_sequence_data_new[g_this_sequence][jp+count-1]='.';
   }
   /* fix A or number 2 and adjust all others */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    if(sequence!=g_this_sequence) {
      display_insert(sequence,k2,j+1);
      for(pos=(g_sequence_length+1);pos>=(j+1);pos--) {
	g_sequence_data_new[sequence][pos+k2] =
	  g_sequence_data_new[sequence][pos];
      }
      for(count=1;count<=k2;count++) {
	g_sequence_data_new[sequence][j+count]='.';
      }
    }
  }
 }
 if(k2<0) { /* fix A or number 3 */
   nk2 = -k2;
   printf("Moving selected %s left %d", g_sequence_name[g_this_sequence],nk2);
   for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
     if(sequence!=g_this_sequence) {
       display_insert(sequence,nk2,jp);
       for(pos=(g_sequence_length+1);pos>=(jp);pos--) {
	 g_sequence_data_new[sequence][pos+nk2]=
	   g_sequence_data_new[sequence][pos];
       }
       for(count=1;count<=nk2;count++) {
	 g_sequence_data_new[sequence][jp+count-1]='.';
       }
     }
   }
   display_insert(g_this_sequence,nk2,j+1);
   for(pos=(g_sequence_length+1);pos>=(j+1);pos--) {
     g_sequence_data_new[g_this_sequence][pos+nk2]=
       g_sequence_data_new[g_this_sequence][pos];
   }
   for(count=1;count<=nk2;count++) {
     g_sequence_data_new[g_this_sequence][j+count]='.';
   }
 }
 length_adjuster=(int)(abs(k2));
 if(k1>0) { /* fix B or number 3 */
   printf("Moving selected %s down %d\n",
	  g_sequence_name[g_this_sequence],k1);
   display_insert(g_this_sequence,k1,i);
   for(pos=(g_sequence_length+1+length_adjuster);pos>=i;pos--) {
     g_sequence_data_new[g_this_sequence][pos+k1]=
       g_sequence_data_new[g_this_sequence][pos];
   }
   for(count=1;count<=k1;count++) {
     g_sequence_data_new[g_this_sequence][i+count-1]='.';
   }
   /* fix A or number 2 */
   for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
     if(sequence!=g_this_sequence) {
       display_insert(sequence,k1,ip+1);
       for(pos=(g_sequence_length+1+length_adjuster);pos>=(ip+1);pos--) {
	 g_sequence_data_new[sequence][pos+k1]=
           g_sequence_data_new[sequence][pos];
       }
       for(count=1;count<=k1;count++) {
	 g_sequence_data_new[sequence][ip+count]='.';
       }
     }
   }
 }
 if(k1<0) { /* fix A or number 3 */
    nk1 = -k1;
    printf("Moving selected %s up %d\n",
	   g_sequence_name[g_this_sequence],nk1);
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      if(sequence!=g_this_sequence) {
	display_insert(sequence,nk1,i);
	for(pos=(g_sequence_length+1+length_adjuster);pos>=(i);pos--) {
	  g_sequence_data_new[sequence][pos+nk1]=
	    g_sequence_data_new[sequence][pos];
        }
	for(count=1;count<=nk1;count++) {
	  g_sequence_data_new[sequence][i+count-1]='.';
	}
      }
    } 
    display_insert(g_this_sequence,nk1,ip+1);
    for(pos=(g_sequence_length+1+length_adjuster);pos>=(ip+1);pos--) {
      g_sequence_data_new[g_this_sequence][pos+nk1]=
	g_sequence_data_new[g_this_sequence][pos];
    }
    for(count=1;count<=nk1;count++) {
      g_sequence_data_new[g_this_sequence][ip+count]='.';
    }
    /* end of my way */
 }
 /* remove duplicate insertions, move back 1 position */
 for(pos=0;pos<=(new_length);pos++) {
   for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
     g_sequence_data_new[sequence][pos]=
       g_sequence_data_new[sequence][pos+1];
   }
 }
 pos=0;
 new_length=remove_duplicates(pos,new_length);
 printf("I                                      I\n");  
 printf("IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII\n");
 return new_length;
}

void set_close_range (int);
void main_initialize(void);

void restart_program(int new_length) {
  g_first_run=FALSE;
  g_new_length=new_length;
  if(g_i_row>new_length)
     g_i_row=new_length;
  if(g_j_col>new_length)
     g_j_col=new_length;
  main_initialize();
}

void make_overlaps_initialize(void) {
  /* Copy each diagonal from save to g_diag
   * and split helices based on inserts. sort them.
   * Make overlaps, append them to g_diag, and sort again */
  int i,diag;
  int position,start,current_helix,seq;
  printf("Helices in plot and/or ct files: %d\n", g_used_saved_helix);
   g_helices_used=0;
  for(diag=1;diag<=g_last_diagonal;diag++)
     g_diag_count[diag]=0;
  for(diag=1;diag<=g_last_diagonal;diag++) {
    start=g_saved_helix_start[diag];
    /* for each diagonal
     * For helices that match filter and cutoff
     * copy them from saved to insert them in g_diag */
    for(current_helix=1;current_helix<=g_saved_helix_count[diag];
	current_helix++) {position
	=start+current_helix-1;
      seq=g_saved_helix[position].color;
      if(seq<=g_adjust_last_used_sequence) {
	if((g_saved_helix[position].length >= g_chain_len) &&
	   (g_saved_helix[position].energy <= g_energy_cutoff[seq])) {
	  split_insert(g_saved_helix[position].length,
		       g_saved_helix[position].row,
		       g_saved_helix[position].column,
		       g_saved_helix[position].energy, seq);
	}
      }
    }
  }
  sort_helices();
  /* reset starts to reflect helices after inserts of alignment file */
  g_diag_start[1]=0;
  for(i=2;i<=g_last_diagonal;i++)
    g_diag_start[i]=g_diag_start[i-1]+g_diag_count[i-1];
  printf("Helices after inserts, before overlaps %d\n",g_helices_used);
  find_overlap();
  sort_helices();
  /* reset starts after inclusion of overlaps */
  g_diag_start[1]=0;
  /* printf("g_last_diagonal is %d\n",g_last_diagonal); */
  for(i=2;i<=g_last_diagonal;i++)
    g_diag_start[i]=g_diag_start[i-1]+g_diag_count[i-1];
  printf("Helices including overlap %d\n",g_helices_used);
}

void set_start_saved(void) {
  int i;
  g_saved_helix_start[1]=0;
  for(i=2;i<=(g_sequence_length*2-1);i++) {
    g_saved_helix_start[i]=g_saved_helix_start[i-1]+
      g_saved_helix_count[i-1];
  }
}

void  first_initialize(void) {
  int i;
  g_used_saved_helix=0; /* indicate that there are no helices in
			   g_saved_helix */ 
  strcpy(g_saved_alignment_name,"save.mal");
  for(i=0;i<TOTAL_SEQUENCES;i++)
    g_file_is_ct[i]=FALSE; /* default to all plot files */
  get_count(); /* find out how many sequences there are */
  g_sequence_length=0;     /* length including inserts */
  get_alignment_first();/* reads alignment file for g_count_sequences */
  initialize_first_initialize();
  /* initializes optimal energy high, worst energy low, zero helices */
  get_plot_files(); /* read plot file and convert entries based on alignment */
  sort_helices_saved(); /* sort entries within g_saved_helix.
			 * g_used_saved_helix contains number of used
			 * helices; (???) alignment file and store
			 * these values as helices on diagonals in memory */
  set_start_saved(); /* set start and count for g_saved_helix */
  g_adjust_last_used_sequence = g_last_used_sequence;
  g_adjust_count_sequences = g_count_sequences;
  make_overlaps_initialize(); 
  /* for each diagonal, make overlaps, sort, copy to g_diag */
  strcpy(g_label_default[1],PROGRAM_NAME".sel");
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_label_default[i],plot_filename_short[i]);
    strcat(g_label_default[i],".sel");
  }
}

void  main_initialize(void) {
  g_best_position_zoom=0;
  if(g_count_neighbors>0) {
    free(g_neighbor_keeper_row);
    free(g_neighbor_keeper_column);
    g_count_neighbors=0;
    g_neighbor_distance=0;
  }
  get_alignment_main(); /* reads alignment file for g_count_sequences */
  /* initializes optimal energy high, worst energy low, zero helices */
  make_overlaps_initialize();
}

void undo_insertions(void) {
  int next_length,temp_length;
  int i;
  if(g_first_run) {
    printf("No insertions have been performed.\n");
    return;
  } else
    printf("Undo last insertion/deletion.\n");
  temp_length=g_sequence_length;
  /* copy previous to new for next run */
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_new[i],g_sequence_data_previous[i]);
  }
  next_length=g_sequence_length_previous;
  create_align_file(next_length,FALSE);
  /* copy previous2 to previous */
  g_sequence_length_previous=g_sequence_length_previous2;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_previous[i],
	   g_sequence_data_previous2[i]);
  }
  g_first_run = FALSE;
  /* copy current to previous2 */
  g_sequence_length_previous2=temp_length;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_previous2[i],g_sequence_data[i]);
  }
  restart_program(next_length);
}

void set_original(void) {
  int next_length;
  int i;
  if(g_first_run) {
    printf("Still showing original data.\n");
    return;
  } else 
    printf("Returning to original data.\n");
  /* set original data back */
  next_length=g_sequence_length_original;
  g_first_run=FALSE;
  /* store previous in previous2 */
  g_sequence_length_previous2=g_sequence_length_previous;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_previous2[i], g_sequence_data_previous[i]);
  }
  /* store current in previous */
  g_sequence_length_previous = g_sequence_length;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_previous[i],g_sequence_data[i]);
  }
  /* return data  for each sequence i */
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_new[i],g_sequence_data_original[i]);
  } 
  create_align_file(next_length,FALSE);
  restart_program(next_length);
}

void set_saved_align(void) {
  int next_length;
  int i;
  printf("Returning to data from last save.\n");
  /* set original data back */
  next_length=g_sequence_length_saved;
  g_first_run=FALSE;
  /* store previous in previous 2*/
  g_sequence_length_previous2=g_sequence_length_previous;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_previous2[i], g_sequence_data_previous[i]);
  }
  /* store current in previous */
  g_sequence_length_previous=g_sequence_length;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_previous[i],g_sequence_data[i]);
  }
  /* return data  for each sequence i */
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(g_sequence_data_new[i],g_sequence_data_saved[i]);
  } 
  create_align_file(next_length,FALSE);
  restart_program(next_length);
}

void delete_insert(int seq,int position,int deletes) {
  /* first store old sequence */
  int i,sequence;
  int new_length;
  int temp_deletes; 
  int check_position;
  char text[40];
  /* int pos; copy current to previous */
  /* double check that all deletes are possible */
  temp_deletes = 0;
  check_position = position + deletes - 1;
  while ( (temp_deletes<deletes) &&  
	  (g_sequence_data[seq+1][check_position-1]=='.') ) {
    temp_deletes++;
    check_position--;
  }
  position = position + deletes - temp_deletes;
  deletes = temp_deletes;
  /* store previous in previous2 */ 
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence], 
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* store current in previous */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence], g_sequence_data[sequence]);
  }
  g_sequence_length_previous=g_sequence_length;
  for(i=position;i<=g_sequence_length;i++)
    g_sequence_data[seq+1][i-1] = g_sequence_data[seq+1][i+deletes-1];
  for(i=1;i<=deletes;i++)
    strcat(g_sequence_data[seq+1],"."); /* length unchanged */
  new_length = g_sequence_length;
  /* remove duplicates
   * copy sequences to new 
   */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_new[sequence], g_sequence_data[sequence]);
  }
  /* new_length=remove_duplicates(pos,new_length); */
  create_align_file(new_length,FALSE);
  strcpy(text,"Remove ");
  strcat(text,num_string_int(deletes));
  strcat(text," inserts");
  restart_program(new_length);
}

void place_insert(int seq,int position,int number_inserts) {
  /* first store old sequence */
  int i,sequence;
  int new_length;
  char text[50];
  /* int pos; */
  /* store previous in previous2 */ 
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence], 
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* store current in previous */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence], g_sequence_data[sequence]);
  }
  g_sequence_length_previous = g_sequence_length;
  for(i=g_sequence_length;i>=(position-1);i--)
    g_sequence_data[seq+1][i+number_inserts] =  g_sequence_data[seq+1][i];
  for(i=0;i<number_inserts;i++)
    g_sequence_data[seq+1][position-1+i]='.';
     /* place insertion at end of other sequences */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    if(sequence!=(seq+1)) {
      for(i=1;i<=number_inserts;i++)
	strcat(g_sequence_data[sequence],".");
    }
  }
  /* length increases */
  new_length = g_sequence_length+number_inserts;
  /* remove duplicates */
 /* pos=position-1; */

 for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
   strcpy(g_sequence_data_new[sequence], g_sequence_data[sequence]);
 }
 /* copy sequences to new */
 create_align_file(new_length,FALSE);
 strcpy(text,"Place ");
 strcat(text,num_string_int(number_inserts));
 strcat(text," insert(s)");
 restart_program(new_length);
}

void make_menu(int);

void make_switch_with1(int seq) {
  int i;
  seq++;
  g_primary_sequence=seq;
  if(g_last_used_sequence>3) {
    g_primary_helix_index=-1;
    for(i=2;i<=g_last_used_sequence;i++) {
      printf("Set sequence %d was not used.\n",i);
      g_drag_this_row_from[i] = -1;
     }
   }
}

/* Make pretty alignment */

void display_time(FILE *fp) {
  time_t now;
  now=time(NULL);
  fprintf(fp,"\n%s %s","%%",ctime(&now));
}

void initialize_align_fp_ps(void) {
  fprintf(align_fp,"%c!PS-Adobe-3.0 EPSF-2.0\n",'%');
  fprintf(align_fp,"%sBoundingBox: 0 0 612 792\n","%%");
  fprintf(align_fp,"\n%s Created by %s, %s\n","%%", 
	  PROGRAM_NAME, PACKAGE_STRING);
  display_time(align_fp);
  fprintf(align_fp,"%s\n%s\n","%%","%%");
  fprintf(align_fp," %f %f scale\n",1.0,1.0);
  fprintf(align_fp,"%s\n","%%");
  fprintf(align_fp,"%s To change image size ....\n","%%");
  fprintf(align_fp,"%s For full size image Use Bound ngBox:0 0 612 792\n",
          "%%");
  fprintf(align_fp,"%s                     and 1.0 1.0 scale\n","%%");
  fprintf(align_fp,"%s For image .25 of full size, replace 612 with .25*612\n",
               "%%");
  fprintf(align_fp,"%s                replace 792 with .25*792 and replace\n",
               "%%");
  fprintf(align_fp,
         "%s                1.0 with .25: Other scales are similar.\n","%%");
  fprintf(align_fp,"%s                Valid scales are .05 to 1.00\n","%%");
  fprintf(align_fp,
        "%s ONLY scale and Bound ngBox lines above should be changed.\n","%%");
  fprintf(align_fp,"%s\n","%%");
  fprintf(align_fp,"%sPage: 1 1\n","%%");
  fprintf(align_fp,"645 0 translate\n");
  fprintf(align_fp,"90 rotate\n");
  fprintf(align_fp,"\n /Courier findfont");
  fprintf(align_fp,"\n 20 scalefont");
  fprintf(align_fp,"\n setfont");
  fprintf(align_fp,"\n 200 600 moveto");
  fprintf(align_fp,"\n (Alignment file from %s) show", PROGRAM_NAME);
  fprintf(align_fp,"\n /Courier findfont");
  fprintf(align_fp,"\n 9 scalefont");
  fprintf(align_fp,"\n setfont");
}

void end_page(void) {
  fprintf(align_fp,"\n showpage\n");
  fprintf(align_fp,"%sEOF\n","%%");
}

void general_align(void) {
  int complete_rows;
  int k,next_char,j,row,sequence;
  char  all_dot[132];
  char piece[101];
  char bar_line[132];
  int page;
  char new_name[7][32];
  float current_y,current_x;
  int label[11];
  int i;
  page=1;
  label[0]=1;
  label[1]=10;
  label[2]=20;
  label[3]=30;
  label[4]=40;
  label[5]=50;
  label[6]=60;
  label[7]=70;
  label[8]=80;
  label[9]=90;
  label[10]=100;
  for(i=2;i<=g_last_used_sequence;i++) {
    strcpy(new_name[i],g_sequence_name[i]);
    new_name[i][28]='\0';
  }
  initialize_align_fp_ps();
  complete_rows=g_sequence_length/100;
  strcpy(bar_line,"                               |        |         |         |         |         |         |         |         |         |         |");
  current_x=40;
  current_y=595;
  for(row=1;row<=complete_rows;row++) {
    current_y=current_y-20;
    if(current_y<150+(g_count_sequences-2)*20) {
      fprintf(align_fp,"\n showpage\n");
      current_y = 600;
      page++;
      fprintf(align_fp,"%sPage: %d %d\n","%%",page,page);
      fprintf(align_fp,"645 0 translate\n");
      fprintf(align_fp,"90 rotate\n");
    }
    fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y);
    fprintf(align_fp,"(                            %4d     %4d      %4d      %4d      %4d      %4d      %4d      %4d      %4d      %4d      %4d) show\n",label[0],label[1],label[2],label[3],label[4],label[5],label[6],label[7],label[8],label[9],label[10]);
    strcpy(all_dot, "                               ----------------------------------------------------------------------------------------------------");
    current_y = current_y - 10;
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y);
      fprintf(align_fp,"(%28s",new_name[sequence]);
      fprintf(align_fp,"%4d     %4d      %4d      %4d      %4d      %4d      %4d      %4d      %4d      %4d      %4d) show\n",
	      g_reverse_st[sequence][label[0]],
	      g_reverse_st[sequence][label[1]],
	      g_reverse_st[sequence][label[2]],
	      g_reverse_st[sequence][label[3]],
	      g_reverse_st[sequence][label[4]],
	      g_reverse_st[sequence][label[5]],
	      g_reverse_st[sequence][label[6]],
	      g_reverse_st[sequence][label[7]],
	      g_reverse_st[sequence][label[8]],
	      g_reverse_st[sequence][label[9]],
	      g_reverse_st[sequence][label[10]]
	      );
      current_y=current_y-10;
    }
    current_y+=2;
    for(i=0;i<=10;i++)
      label[i]+=100; 
    fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y);
    current_y-=9;
    fprintf(align_fp,"(%s) show\n",bar_line); 
    for(j=1;j<=100;j++)
    if(!check_same_base((row-1)*100+j-1))
         all_dot[30+j]=' ';
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      for(j=1;j<=100;j++) {
	piece[j-1] = g_sequence_data[sequence][(row-1)*100+j-1];
        if(piece[j-1]!='.') {
	  if(all_dot[30+j]==' ')
            piece[j-1]=tolower(piece[j-1]);
	  else
            piece[j-1]=toupper(piece[j-1]);
	}
      }
      piece[100] = '\0';
      fprintf(align_fp,"\n %.1f %.1f moveto\n", current_x,current_y);
      current_y-=10;
      fprintf(align_fp,"(%30s %s) show \n", g_sequence_name[sequence], piece);
    }
    current_y += 3;
    fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y); 
    current_y -= 10;
    fprintf(align_fp,"(%s) show \n",all_dot);
  }
  next_char = complete_rows*100;
  if(next_char<g_sequence_length) {
    if(current_y<(150+(g_count_sequences-2)*20)) {
      fprintf(align_fp,"\n showpage\n");
      current_y=600;
      page++;
      fprintf(align_fp,"%sPage: %d %d\n","%%",page,page);
      fprintf(align_fp,"645 0 translate\n");
      fprintf(align_fp,"90 rotate\n");
    }
    strcpy(all_dot,
	   "                               ----------------------------------------------------------------------------------------------------");
    for(j=next_char,k=0;j<g_sequence_length;j++,k++) {
      if(!check_same_base(j))
	all_dot[31+k]=' ';
    }
    all_dot[30+k+1]='\0';
    bar_line[30+k]='|';
    bar_line[30+k+1]='\0';
    current_y -= 20;
    fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y); 
    fprintf(align_fp,"(                            %4d",label[0]);
    for(j=label[1],i=1;j<(g_sequence_length-5);j+=10,i++)
      fprintf(align_fp,"      %4d",label[i]);
    for(i=(j-10)+4;i<g_sequence_length;i++)
      fprintf(align_fp," ");
    fprintf(align_fp,"%4d) show\n",g_sequence_length);
    current_y -= 10;
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y);
      current_y -= 10; 
      fprintf(align_fp,"(%28s",new_name[sequence]);
      fprintf(align_fp,"%4d",g_reverse_st[sequence][label[0]]);
      for(j=label[1],i=1;j<(g_sequence_length-5);j+=10,i++)
	fprintf(align_fp,"      %4d", g_reverse_st[sequence][label[i]]);
      for(i=(j-10)+4;i<g_sequence_length;i++)
	fprintf(align_fp," ");
      fprintf(align_fp,"%4d) show \n",
	      g_reverse_st[sequence][g_sequence_length]);
    }
    current_y++;
    fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y); 
    current_y -= 9;       
    fprintf(align_fp,"(%s) show\n",bar_line);
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      for(j=next_char,k=0;j<g_sequence_length;j++,k++) {
	piece[k]=g_sequence_data[sequence][j];
	if(piece[k]!='.') {
	  if(all_dot[31+k]==' ')
            piece[k]=tolower(piece[k]);
	  else
            piece[k]=toupper(piece[k]);
	}
      } 
      piece[k]='\0';
      fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y); 
      current_y-=10;
      fprintf(align_fp,"(%30s %s) show \n",g_sequence_name[sequence], piece);
    }
    current_y += 3;
    fprintf(align_fp,"\n %.1f %.1f moveto\n",current_x,current_y); 
    fprintf(align_fp,"(%s) show\n",all_dot);
  }
  end_page();
  fclose(align_fp);
}

void finish_making_align_ps(void) {
  int error;
  g_message_set=FALSE;
  text_window_message[0]='\0';
  glutSetWindow(win3);
  glutPostRedisplay();
  fix_cursor();
  if(strlen(text_window_input)==0)
    strcpy(fancy_align_filename,"sequence_align");
  else
    strcpy(fancy_align_filename, text_window_input);
  chop_suffix(fancy_align_filename, ".ps");
  strcat(fancy_align_filename,".ps");
  text_window_input[0]='\0';
  if((fancy_align_filename[0]=='/')||(strlen(fancy_align_filename)==1))
    return;
  printf("Name for alignment file: %s\n", fancy_align_filename);
  error = open_fancy_align();
  if(error) {
    printf("Error creating alignment file #%d.\n",error);
    return;
  }
  general_align();
}

void finish_making_align_mal(int use_save_mal) {
  int sequence;
  if(!use_save_mal) {
    g_message_set=FALSE;
    text_window_message[0]='\0';
    glutSetWindow(win3);
    glutPostRedisplay();
    fix_cursor();
    if(strlen(text_window_input)==0)
      strcpy(fancy_align_filename, g_saved_alignment_name);
    else
      strcpy(fancy_align_filename, text_window_input);
    if(strlen(fancy_align_filename) == 0) {
      text_window_input[0]='\0';
      return;
    }
    chop_suffix(fancy_align_filename, ".mal");
    strcat(fancy_align_filename,".mal");
    strcpy(g_saved_alignment_name, fancy_align_filename);
    text_window_input[0]='\0';
  } else
    strcpy(fancy_align_filename,"save.mal");
  create_align_file(g_sequence_length,TRUE);
  /* copy to sequence saved data */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++)
    strcpy(g_sequence_data_saved[sequence], g_sequence_data[sequence]);
  g_sequence_length_saved=g_sequence_length;
  printf("Just reset back up to save data\n");
}

/* Find best insertion */
int count_best_insert_diagonal(int diag, int sequence, int left, int right,
			       int top, int bottom, int current_place,
			       int *long_array) {
  int i;
  int positions[TOTAL_SEQUENCES];
  int jrow,jcol;
  int true_diag,count;
  int overlaps,position,seq,helices,temp_length,farthest_position;
  overlaps=0;
  positions[2]=0;
  positions[sequence]=current_place;
  /* start here?????*/
  farthest_position=0; /* keeps track of positions used in long_array */
  for(seq=2;seq<=sequence;seq=seq+sequence-2) { /* execute for 2 & sequence */
    true_diag=diag+close_g_diag_offset[positions[seq]];
    if((true_diag>0)&&(true_diag)<=g_last_diagonal) {
      count = g_diag_count[true_diag];
      for(helices=1;helices<=count;helices++) {
	position = g_diag_start[true_diag]+helices - 1;
	if(g_diag[position].color==seq) {
	  jrow = g_diag[position].row + g_ver_offset[positions[seq]];
	  temp_length=g_diag[position].length;
	  jcol=g_diag[position].column+
	    g_hor_offset[positions[seq]];
	  if((temp_length>=g_chain_len) &&
	     (g_diag[position].energy<=g_energy_cutoff[seq])) {
	    for(i=0;i<temp_length;i++) {
	      if((jcol>=left)&&(jcol<=right) && (jrow>=top)&&(jrow<=bottom)) {
		long_array[jrow-top]++;
		if(jrow>farthest_position)
		  farthest_position=jrow-top;
	      }
	      jrow++;
	      jcol--;
	    }
	  }
	}
      }
    }
  }
  for(i=0;i<=(farthest_position);i++) {
    if(long_array[i]==2) {
      overlaps++;
    }
    long_array[i] = 0;
  }
  return overlaps;
}

int count_best_insert_rectangle(int sequence, int left, int right, 
				int top, int bottom, int current_place, 
				int *long_array) {
  int start_diag,end_diag;
  int diag;
  int overlaps;
  overlaps = 0;
  start_diag = left + top - 1;
  end_diag=right+bottom-1;
  printf("Insert at %d in sequence %d for l=%d,r=%d,t=%d,b=%d\n",
          current_place,sequence-1,left,right,top,bottom);
  for(diag=start_diag;diag<=end_diag;diag++) {
    overlaps = overlaps + 
      count_best_insert_diagonal(diag, sequence, left, right, top, 
				 bottom, current_place, long_array);
  }
  return overlaps;
}

void best_insert(int current_sequence,int left,int right,int top,int bottom) {
  /* current_sequence is selected from adjust of menu 
   * left, right, top, bottom define the region to search for the best
   * insertion. Place insertion at left to right + 1, right + 1 is
   * none. Place insertion at top to bottom + 1 
   */
  int current_place;
  int best_row;
  int best_col;
  int overlaps_best_row;
  int overlaps_best_col;
  int temp_overlaps;
  int long_length;
  int *long_array;
  int i2;
  long_length=top-bottom+10;
  printf("top is %d, bottom is %d\n",top,bottom);
  long_array=(int *)malloc(long_length*sizeof(int));
  if(long_array==NULL) {
    printf("Error!\tInsufficient memory for long array of cch\n");
    try_exit(22);
  }
  for(i2=0;i2<(long_length);i2++)
    long_array[i2]=0;
  overlaps_best_row=INT_MIN;
  overlaps_best_col=INT_MIN;
  best_row=0;
  best_col=0;
  /* check rows */
  for(current_place=top;current_place<=(bottom+1);current_place++) {
    temp_overlaps = 
      count_best_insert_rectangle(current_sequence, left, right, top, bottom,
				  current_place, long_array);
    if(temp_overlaps>overlaps_best_row) {
      overlaps_best_row=temp_overlaps;
      best_row=current_place;
    }
    printf("overlaps for insert at row %d is %d\n",
	   current_place, temp_overlaps);
  }
  printf("Best row is %d with %d overlaps.\n",best_row,overlaps_best_row);
  /* check columns */
  for(current_place=left;current_place<=(right+1);current_place++) {
    temp_overlaps = 
      count_best_insert_rectangle(current_sequence, left, right, top, bottom,
				  current_place, long_array);
    if(temp_overlaps>overlaps_best_col) {
      overlaps_best_col = temp_overlaps;
      best_col = current_place;
    }
  }
  printf("Best column is %d with %d overlaps.\n",best_col, overlaps_best_col);
  free(long_array);
}

/* Extra section for reading ct files  */

void read_ct_file(int sequence) {
  char record[110];
  int file_length;
  int row,previous,next,column,junk;
  int helix_len;
  int ct_row,ct_column;
  int helices_in_this_file; 
  char base;
  char energy_string[80];
  int first_char;
  int helix_started;
  int j,i;
  int sequence_length;
  int previous_column;
  int name_start;
  int energy_start;
  int record_length;
  char junk_length[120];
  float ct_energy;
  sequence_length = 0;
  /* diag is the diagonal that each row,col corresponds to */
 helices_in_this_file=0;
 if(fgets(record,105,file)==NULL) {
   printf("Error!\tct file is completely empty.\n");
   try_exit(23);
 } else {
   /* record should look like  741 dG =  -238.3    mok-lacZ + gtgtaa 
    * 741 is length of sequence, mok-lacZ + gtgtaa is the name
    * The energy varies and is stored as file_data_ct */
   sscanf(record,"%d",&file_length); /* assign length */
   if(file_length!=g_nucleotide_total[sequence]) {
     printf("Error!\tAlignment file indicates length of %d\n",
            g_nucleotide_total[sequence]);
     printf("but the ct file indicates length of %d\n",file_length);
     try_exit(24);
   }
   sscanf(record,"%s",junk_length); /* assign length string */
   first_char=0;
   name_start=0;
   energy_start=0;
   record_length=strlen(record);
   while((isspace(record[first_char]))&&(first_char<record_length))
     first_char++;/* Advance through spaces of record */
   while(isdigit(record[first_char])) /*advance through numbers of record */
     first_char++;
   while((isspace(record[first_char]))&&(first_char<record_length))
     first_char++; /* advance through spaces */
   energy_start=first_char;
   while((!isspace(record[first_char]))&&(first_char<record_length))
     first_char++; /* advance through energy */
   while((isspace(record[first_char]))&&(first_char<record_length))
     first_char++; /* advance through spaces */
   while((!isspace(record[first_char]))&&(first_char<record_length))
     first_char++; /* advance through = */
   while((isspace(record[first_char]))&&(first_char<record_length))
     first_char++; /* advance through spaces */
   while((!isspace(record[first_char]))&&(first_char<record_length))
     first_char++; /* advance through = number*/
   name_start=first_char;
   if(name_start>30) {
     /* failed to find energy */
     name_start=6;
     ct_energy=0.0;
     g_optimal_energy[sequence]=0;
     g_worst_energy[sequence]=0;
     strcpy(energy_string,"Energy is Undef.");
   } else {
     for(i=energy_start,j=0;i<name_start;i++,j++)
       energy_string[j]=record[i];
     energy_string[j]='\0';
     sscanf(energy_string,"%*s%*s%f",&ct_energy);
     ct_energy=ct_energy*10;
     g_optimal_energy[sequence]=(int)(ct_energy);
     g_worst_energy[sequence]=(int)(ct_energy);
   }
 }
 /* Read the ct file */
 helix_started = FALSE;
 helix_len = 0;
 ct_row = -99; /* initialize to avoid warning messages */
 ct_column = -99;
 previous_column = -10;
 sequence_length = 0; 
 while(fgets(record,90,file)!=NULL) {
   sscanf(record,"%d %c %d %d %d %d", &row, &base, &previous, &next, &column,
	  &junk);
   if(row!=(sequence_length+1)) {
     printf("Error in ct file. Format is wrong\n");
     printf("Record %d of the file contains %s,\n", sequence_length+1, record);
     printf("but it should start with %d\n",sequence_length+1);
     try_exit(25);
   }
   sequence_length++;
   if(helix_started==TRUE) {
     if(column==0) {
       /* finish off helix */  
       saved_append(helix_len,ct_row,ct_column,ct_energy,sequence);
       helices_in_this_file++;
       helix_started=FALSE;
     } else if(column<row) {  
       /* col < row has already been added so finish off helix. All
	  helices appear twice */ 
       saved_append(helix_len,ct_row,ct_column,ct_energy,sequence);
       helices_in_this_file++;
       helix_started = FALSE; /* just finish current helix */
     } else if(column!=(previous_column-1)) { /* finish off helix */
       saved_append(helix_len,ct_row,ct_column,ct_energy,sequence);
       helices_in_this_file++;
       helix_started=FALSE;
       /* start new helix */
       previous_column=column;
       helix_len=1;
       ct_row=row;
       ct_column=column;
       helix_started=TRUE;
     } else {
       helix_len++; /* add one to length */
       previous_column=column;
     }
   } else {
     /* helix has not been started */
     if(column>row) { /* start a helix */
       previous_column=column;
       helix_len=1;
       ct_row=row;
       ct_column=column;
       helix_started=TRUE;
     }
   }
 }
 /* end of while loop 
  * if a helix was started, record its length */
 if(helix_started==TRUE) {
   saved_append(helix_len,ct_row,ct_column,ct_energy,sequence);
   helices_in_this_file++;
 }
 printf("There are %d helices in this ct file with length %d.\n",
	helices_in_this_file,file_length); 
 if(file_length!=sequence_length) {
   printf("Error!\tThere are %d records, but the first line ",
	  sequence_length);
   printf("indicates that there should be %d records.\n",
	  file_length);
   try_exit(26);
 }
}

void translate_ct_file(int sequence,char *name_of_file) {
  printf("Translating ct file for sequence %d with filename %s\n",
	 sequence-1, name_of_file);
  g_prob = FALSE;
  read_ct_file(sequence);
  return;
}

/*
 * Create a file of neighbors for the given sequence within given distance
 */
FILE *nfp;
int open_neighbor(char *filename) {
  if ((nfp = fopen(filename, "w")) == NULL) {
    printf ("Error!\tCould not open file: %s.\n", filename);
    return(1);
  }
  return (0);
}

int open_neighbor_r(char *filename) {
  if ((nfp = fopen(filename, "r")) == NULL) {
    printf ("Error!\tCould not open file: %s.\n", filename);
    return(1);
  }
  return (0);
}

void write_neighbor_helix_basepair(int row,int column,int distance, 
				   int sequence) {
  int original_row, original_column;
  if((row<1) || (column<1) || (row>g_sequence_length) || 
     (column>g_sequence_length))
    return;
  if(column<=row)
    return;
  original_row=g_reverse_st[sequence][row];
  original_column=g_reverse_st[sequence][column];
  /* nonzero positions exist and are printed */
  if((original_row)&&(original_column)) {
    fprintf(nfp,"%5d %5d %5d\n",original_row,original_column,distance);
    g_count_neighbors++;
  }
}

void write_neighbor_helix(int sequence,int location,int distance) {
  int start_row,start_column;
  int length;
  int i;
  int d;
  int row,column;
  length=g_diag[location].length;
  start_row=g_diag[location].row;
  start_column=g_diag[location].column;
  /* write out the zero distance*/
  for(i=0;i<length;i++)
    write_neighbor_helix_basepair(start_row+i,start_column-i,0,sequence);
  /* for other distances
   * write dots, starting at top left, going counter
   clockwise around the helix */
  for(d=1;d<=distance;d++) { /* top left corner */
    row=start_row-d;
    column=start_column+d;
    write_neighbor_helix_basepair(row,column,d,sequence);
    /* top row, coming left */
    for(i=1;i<=(2*d);i++) {
      column--;
      write_neighbor_helix_basepair(row,column,d,sequence);
    }
    /* left side, diagonal */
    for(i=1;i<=(length-1);i++) {
      row++;
      write_neighbor_helix_basepair(row,column,d,sequence);
      column--;
      write_neighbor_helix_basepair(row,column,d,sequence);
    }
    /* down to bottom left corner */
    for(i=1;i<=(2*d);i++) {
      row++;
      write_neighbor_helix_basepair(row,column,d,sequence);
    }
    /* go across bottom */
    for(i=1;i<=(2*d);i++) {
      column++;
      write_neighbor_helix_basepair(row,column,d,sequence);
    }
    /* go up right diagonal */
    for(i=1;i<=(length-1);i++) {
      row--;
      write_neighbor_helix_basepair(row,column,d,sequence);
      column++;
      write_neighbor_helix_basepair(row,column,d,sequence);
    }
    /* go up to top right corner */
    for(i=1;i<=(2*d-1);i++) {
      row--;
      write_neighbor_helix_basepair(row,column,d,sequence);
    }
  }
}

void write_neighbors(int sequence,int distance) {
  int seq,location;
  for(location=0;location<g_helices_used;location++) {
    seq=g_diag[location].color;
    if(seq==g_primary_sequence)
      write_neighbor_helix(sequence,location,distance);
  }
}

void create_neighbors(int sequence,int distance) {
  int error;
  char action[250];
  char neighbor_file[120];
  if(g_count_neighbors>0) {
    g_count_neighbors=0;
    free(g_neighbor_keeper_row);
    free(g_neighbor_keeper_column);
  }
  /* open file */
  strcpy(neighbor_file,plot_filename_short[g_primary_sequence]);
  strcat(neighbor_file,".nbh");
  g_count_neighbors=0;
  if(open_neighbor(neighbor_file)) {
    printf("Error!\tCould not open file for close with computation./n");
    return;
  }
  printf("Writing outputput to file:%s\n",neighbor_file);
  write_neighbors(sequence,distance);
  fclose(nfp);
  /* sort the file by rows, columns, distance */
  strcpy(action,"sort -u -o ");
  strcat(action,neighbor_file); 
  strcat(action," ");
  strcat(action,neighbor_file); 
  strcat(action,"\n");
  error=system(action);
  if(error!=0) {
    printf("Error!\tSorting %s from %s. The action was %s.\n",
	   neighbor_file, PROGRAM_NAME, action);
    g_count_neighbors=0;
    g_neighbor_distance=0;
    return;
  }
  /* set up for display of neighbors */
  if(g_count_neighbors==0) {
    printf("No neighbors exist.\n");
    return;
  }
  g_neighbor_keeper_row=(int *)malloc(sizeof(int)*g_count_neighbors);
  if(g_neighbor_keeper_row==NULL) {
    printf("Error!\tInsufficient memory for displaying neighbors, row.\n");
    g_count_neighbors=0;
    g_neighbor_distance=0;
    return;
  }
  g_neighbor_keeper_column=
    (int *)malloc(sizeof(int)*g_count_neighbors);
  g_count_neighbors=0;
  /* open file for reading */
  if(g_neighbor_keeper_column==NULL) {
    printf("Error!\tInsufficient memory for displaying neighbors, col\n");
    free(g_neighbor_keeper_row);
    return;
  }
  if(open_neighbor_r(neighbor_file)) {
    printf("Strange error reading file of close.\n"); 
    return;
  }
 while(fscanf(nfp,"%d %d %*d", &g_neighbor_keeper_row[g_count_neighbors],
	      &g_neighbor_keeper_column[g_count_neighbors])==2) {
   g_neighbor_keeper_row[g_count_neighbors]=
     g_sequence_translator[sequence][g_neighbor_keeper_row[g_count_neighbors]];
   g_neighbor_keeper_column[g_count_neighbors] =
     g_sequence_translator[sequence][g_neighbor_keeper_column[g_count_neighbors]];
   g_count_neighbors++;
 }
 fclose(nfp);
}

/* Drag a helix */

void swap(int *i,int *j) { /* swap values of i and j */
  int temp;
  temp=*i;
  *i=*j;
  *j=temp;
}

int abs_int(int x) {
  if(x<0)
    return -x;
  else
    return x;
}

void make_inserts(int sequence,int num_of_inserts,int place,int length) {
  int base;
  /* use length+1 to get 0 at end move bases forward */
  if(num_of_inserts<1)
    return;
  printf("Placing %d inserts at alignment position %d for sequence %d.\n",
	 num_of_inserts,place,sequence-1);
  for(base=(length+1);base>=place;base--) {
    g_sequence_data_new[sequence][base+num_of_inserts]=
      g_sequence_data_new[sequence][base];    
  }
  /* place inserts */
  for(base=place;base<=(place+num_of_inserts-1);base++) {
    g_sequence_data_new[sequence][base]='.';
  }
} 

void drag_helix(int row1,int col1, int row3,int col3) {
  /* for only 2 sequences */
  int hor_shift,ver_shift;
  int row2,col2,row4,col4;
  int adjust_length;
  int new_length;
  int pos; 
  int sequence;
  int temp;
  int this_length;
  int new_row1,new_col1; /* adjust to be start of helix */
  int new_row3,new_col3; /* adjust to be start of helix */
  int length2,this_index,index2; 
  if(row3>col3) {
    temp=row3;
    row3=col3;
    col3=temp;
  }
  printf("Drag started with (row,col) of (%d,%d).\n",row3,col3);
  this_index=index_energy_read(row1,col1,g_this_sequence);
  if(this_index<0) {
    printf("No helix at (row=%d,col=%d) for sequence %s.\n",
	   row1,col1,g_sequence_name[g_this_sequence]);
    printf("Trying the other order.\n");
    /* swap rows,cols */
    swap(&row1,&row3);
    swap(&col1,&col3);
    this_index=index_energy_read(row1,col1,g_this_sequence);
    if(this_index<0) {
      printf("No helix at (row=%d,col=%d) for sequence %s.\n",
	     row1,col1,g_sequence_name[g_this_sequence]); 
      printf("No drag performed\n");
      return;
    }
  }
  /* make adjustments to move entire helix */
  this_length=g_diag[this_index].length;
  new_row1=g_diag[this_index].row;
  new_col1=g_diag[this_index].column;
  index2=index_energy_read(row3,col3,g_primary_sequence);
  if(index2<0) {
    printf("No helix at (row=%d, col=%d) for sequence %s.\n",
	   row3,col3,g_sequence_name[g_primary_sequence]);
    printf("No drag performed.\n");
    return;
  }
  length2=g_diag[index2].length;
  /* adjust to find start of primary helix */
  new_row3=g_diag[index2].row;
  new_col3=g_diag[index2].column;
  /* end of helix for this sequence */
  row2=new_row1+this_length-1;
  col2=new_col1-this_length+1;
  /* end of helix for primary sequence */
  row4=new_row3+length2-1;
  col4=new_col3-length2+1;
  /* these should not be needed ? */
  if(row4>g_sequence_length)
    row4=g_sequence_length;
  if(row2>g_sequence_length)
    row2=g_sequence_length;
  if(col2<1)
    col2=1;
  if(col4<1)
    col4=1;
  /* end of unneeded */
  /* shift to place click dots over each other */
  hor_shift=col3-col1;
  ver_shift=row3-row1;
  printf("Old length was %d.\n",g_sequence_length);
  printf("Horizontal shift is %d, vertical shift is %d.\n",
	 hor_shift,ver_shift);
  /* store previous in previous2 */ 
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence],
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* store old sequences in previous */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence], g_sequence_data[sequence]);
  }
  g_sequence_length_previous=g_sequence_length;
  /* store current in new, but start at position 1 */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    for(pos=0;pos<=g_sequence_length;pos++) {
      g_sequence_data_new[sequence][pos+1] = g_sequence_data[sequence][pos];
    }
    g_sequence_data_new[sequence][0]=' ';
  }
  adjust_length=g_sequence_length;
  if(hor_shift>0) {
    printf("Horizontal shift is > 0.\n");
    /* move this right */
    make_inserts(g_this_sequence,hor_shift,col2,adjust_length);
    make_inserts(g_primary_sequence,hor_shift,new_col3+1,adjust_length);
  }
  if(hor_shift<0) { /* move primary right */
    make_inserts(g_primary_sequence,hor_shift*-1,col4,adjust_length);
    make_inserts(g_this_sequence,hor_shift*-1,new_col1+1,adjust_length);
  }
  adjust_length=adjust_length+abs_int(hor_shift);
  if(ver_shift>0) {
    printf("Vertical shift > 0.\n");
    /* move this down */
    make_inserts(g_this_sequence,ver_shift,new_row1,adjust_length);
    make_inserts(g_primary_sequence,ver_shift,row4+1,adjust_length);
  }
  if(ver_shift<0) { /* move primary down */
    make_inserts(g_primary_sequence,ver_shift*-1,new_row3,adjust_length);
    make_inserts(g_this_sequence,ver_shift*-1,row2+1,adjust_length);
  }
  /* move new back to start at position 0 */
  new_length=g_sequence_length+abs_int(hor_shift)+abs_int(ver_shift);
  for(pos=0;pos<=(new_length);pos++) {
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      g_sequence_data_new[sequence][pos]= g_sequence_data_new[sequence][pos+1];
    }
  }
  printf("new_length is %d (with insertions).\n",new_length);
  new_length=remove_duplicates(0,new_length);
  printf("new_length is %d after removing extra insertions.\n)",new_length);
  create_align_file(new_length,FALSE); 
  /* restart program time to redo alignment and reinitialize */
  restart_program(new_length);
}

int execute_drag_more_than_2_detailed(void) {
  int sequence; 
  int index[TOTAL_SEQUENCES];
  int length[TOTAL_SEQUENCES];
  int start_row[TOTAL_SEQUENCES];
  int start_column[TOTAL_SEQUENCES];
  int end_row[TOTAL_SEQUENCES];
  int end_column[TOTAL_SEQUENCES];
  int top_right_column[TOTAL_SEQUENCES];
  int top_right_row[TOTAL_SEQUENCES];
  int bottom_left_row[TOTAL_SEQUENCES];
  int bottom_left_column[TOTAL_SEQUENCES];
  int amount_to_move_right[TOTAL_SEQUENCES];
  int amount_to_move_down[TOTAL_SEQUENCES];
  int maximum_right_insert;
  int maximum_down_insert;
  int farthest_right_sequence;
  int new_length;
  int lowest_sequence;
  int comp_inserts;
  int move,biggest_move;
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    start_row[sequence]=g_drag_this_row_from[sequence];
    start_column[sequence]=g_drag_this_column_from[sequence];
    if(!g_dot_lower_flag) {
      end_row[sequence]=g_drag_this_row_to[sequence];
      end_column[sequence]=g_drag_this_column_to[sequence];
    } else {
      end_row[sequence]=g_drag_this_column_to[sequence];
      end_column[sequence]=g_drag_this_row_to[sequence];
    }
  }
  /* set primary sequence to go to itself as other sequence does */
  start_row[g_primary_sequence] =  g_diag[g_primary_helix_index].row;
  start_column[g_primary_sequence] = g_diag[g_primary_helix_index].column;
  end_row[g_primary_sequence] = start_row[g_primary_sequence];
  end_column[g_primary_sequence] = start_column[g_primary_sequence];
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    index[sequence] = 
      index_energy_read(start_row[sequence],start_column[sequence],sequence);
  }
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    top_right_column[sequence]=g_diag[index[sequence]].column;
    top_right_row[sequence]=g_diag[index[sequence]].row;
    length[sequence]=g_diag[index[sequence]].length;
    bottom_left_row[sequence]=top_right_row[sequence]+length[sequence]-1;
    bottom_left_column[sequence]=top_right_column[sequence]-length[sequence]+1;
  }
  /* find farthest right sequence */
  biggest_move=0;
  farthest_right_sequence=g_primary_sequence;
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
     if(sequence!=g_primary_sequence) {
       move=start_column[sequence]-end_column[sequence];
       if(move>biggest_move) {
	 biggest_move=move;
         farthest_right_sequence=sequence;
       }
     }
  }
  printf("Farthest right sequence is %d.\n",farthest_right_sequence-1);
  if(farthest_right_sequence!=g_primary_sequence)
    amount_to_move_right[g_primary_sequence]=biggest_move;
  else
    amount_to_move_right[g_primary_sequence]=0;
  printf("amount_to_move_right for primary is %d.\n",
	 amount_to_move_right[g_primary_sequence]);
  amount_to_move_right[farthest_right_sequence]=0;
  maximum_right_insert=amount_to_move_right[g_primary_sequence];
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    if((sequence!=g_primary_sequence)&& (sequence!=farthest_right_sequence)) {
      /* move to primary and then to farthest right */
      amount_to_move_right[sequence] = end_column[sequence] -
	start_column[sequence] + amount_to_move_right[g_primary_sequence];
      if(amount_to_move_right[sequence]>maximum_right_insert)
	maximum_right_insert=amount_to_move_right[sequence];
    }
  }
  printf("max right insert is %d.\n",maximum_right_insert);
  /* make the right inserts */
  if(maximum_right_insert>0) {
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      comp_inserts=maximum_right_insert-amount_to_move_right[sequence];
      make_inserts(sequence,comp_inserts,top_right_column[sequence]+1,
                   g_sequence_length);
      make_inserts(sequence,amount_to_move_right[sequence],
		   bottom_left_column[sequence],
		   g_sequence_length+comp_inserts);
    }
  }
  new_length=g_sequence_length+maximum_right_insert; 
  /* make downward motion
   * find lowest sequence
   * find biggest move upward to primary
   * if it is zero, primary is lowest, otherwise, the sequence generating it is
   */
  biggest_move=0;
  lowest_sequence=g_primary_sequence;
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    if(sequence!=g_primary_sequence) {
      move=start_row[sequence]-end_row[sequence];
      if(move>biggest_move) {
	biggest_move=move;
	lowest_sequence=sequence;
      }
    }
  }
  printf("Lowest sequence is %d.\n",lowest_sequence-1);
  if(lowest_sequence!=g_primary_sequence)
    amount_to_move_down[g_primary_sequence]=biggest_move;
  else
    amount_to_move_down[g_primary_sequence]=0;
  printf("amount_to_move_down for primary is %d.\n",
	 amount_to_move_down[g_primary_sequence]);
  amount_to_move_down[lowest_sequence]=0;
  maximum_down_insert=amount_to_move_down[g_primary_sequence];
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    if((sequence!=g_primary_sequence) && (sequence!=lowest_sequence)) {
      amount_to_move_down[sequence] = end_row[sequence] - start_row[sequence] +
	biggest_move;
      printf("Moving sequence %d down by %d.\n",
	     sequence-1, amount_to_move_down[sequence]);
      if(amount_to_move_down[sequence]>maximum_down_insert)
	maximum_down_insert=amount_to_move_down[sequence];
    }
  }  
  if(maximum_down_insert>0) {
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      comp_inserts=maximum_down_insert-amount_to_move_down[sequence];
      make_inserts(sequence,comp_inserts,bottom_left_row[sequence]+1,
                   new_length);
      make_inserts(sequence,amount_to_move_down[sequence],
		   top_right_row[sequence], new_length+comp_inserts);
    }
  } 
  return g_sequence_length+maximum_right_insert+maximum_down_insert;
}

void execute_drag_more_than_2(void) {
  int pos,new_length,sequence;
  /* for more than 2 sequences 
   * prepare for drag */
  printf("Old length was %d.\n",g_sequence_length);
  /* store previous in previous2 */ 
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence],
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* store old sequences in previous */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence], g_sequence_data[sequence]);
  }
  g_sequence_length_previous=g_sequence_length;
  /* store current in new, but start at position 1 */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    for(pos=0;pos<=g_sequence_length;pos++) {
      g_sequence_data_new[sequence][pos+1] = g_sequence_data[sequence][pos];
    }
    g_sequence_data_new[sequence][0]=' ';
  }
  /* make the drag */
  new_length = execute_drag_more_than_2_detailed();
  /* fix back and prepare to restart */
  for(pos=0;pos<=(new_length);pos++) {
    for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
      g_sequence_data_new[sequence][pos]=g_sequence_data_new[sequence][pos+1];
    }
  }
  printf("new_length is %d (with insertions).\n",new_length);
  new_length=remove_duplicates(0,new_length);
  printf("new_length is %d after removing extra insertions).\n",new_length);
  create_align_file(new_length,FALSE); 
  /* restart program
   * time to redo alignment and reinitialize */
  restart_program(new_length);
}

/* Clean up inserts
 *
 * if only one of each sequence has a base on an interval
 * remove the inserts to make the bases overlap again    
 *
 * return the sequence if all sequences have 1 non-insertion at this pos.
 * otherwise return FALSE =zero 
 */
int single_base_found(int pos) {
  int sequence;
  int total_bases_found;
  int which_sequence = 1;
  sequence=2;
  total_bases_found=0;
  while(sequence<=g_last_used_sequence) {
    if(g_sequence_data_new[sequence][pos]!='.') {
      total_bases_found++;
      which_sequence=sequence;
      if(total_bases_found>1)
	return FALSE;
    }
    sequence++;
  }
  if(total_bases_found==1)
    return which_sequence;
  else
    return FALSE;
}

int remove_single_bases2(int interval_start,int interval_end,int new_length,
			 int sequence) {
  /* start out with an interval of single bases for sequence
   * first find inserts in front or behind
   * first find out how many to delete.
   * the number of deletes in each sequence on this interval 
   */
  int singles;
  int seq;
  int deletes;
  int pos;
  int deletes_left;
  int dots_found;
  singles=interval_end-interval_start+1;
  deletes=0;
  /* find inserts to the left */
  pos=interval_start-1;
  dots_found=0;
  while(((pos>=0)&&(dots_found<singles)) &&
	(g_sequence_data_new[sequence][pos]=='.')) {
    pos--;
    dots_found++;
  }
  if(dots_found>0) {
    deletes=dots_found;
    /* slide sequences left */
    printf("Removing %d inserts found left of pos %d.\n",
	   dots_found,interval_start+1);
    /* slide bases of sequence into the positions of the dots */
    for(pos=interval_start;pos<=interval_start+dots_found-1;pos++) {
      g_sequence_data_new[sequence][pos-dots_found]=
	g_sequence_data_new[sequence][pos];
    }
    /* slide every base left, beyond the singles used */
    for(seq=2;seq<=g_last_used_sequence;seq++) {
      for(pos=interval_start+dots_found;pos<=new_length;pos++) {
	g_sequence_data_new[seq][pos-dots_found] =
	  g_sequence_data_new[seq][pos];
      }
    }
  }
  if(singles==deletes)
    return deletes;
  new_length=new_length-deletes;
  deletes_left=deletes;
  /* remove inserts to right of single
   * reposition to new location of interval.*/
  interval_end=interval_end-deletes;
  singles=interval_end-interval_start+1;
  deletes=0;
  pos=interval_end+1;
  dots_found=0;
  while(((pos<new_length)&&(dots_found<singles)) && 
	(g_sequence_data_new[sequence][pos]=='.')) {
    pos++;
    dots_found++;
  }
  if(dots_found>0) {
    deletes=dots_found;
    /* slide sequences left */
    printf("Removing %d inserts found right of pos %d.\n",
	   dots_found,interval_end+1+deletes_left);
    /* slide bases of sequence into the positions of the dots
     * for the other sequences */
    for(pos=(interval_end+1);pos<=(interval_end+dots_found);pos++) {
      for(seq=2;seq<=g_last_used_sequence;seq++) {
	if(seq!=sequence)
	  g_sequence_data_new[seq][pos-dots_found]=
	    g_sequence_data_new[seq][pos];
      }
    }
    /* slide every base left, beyond the singles used */
    for(seq=2;seq<=g_last_used_sequence;seq++) {
      for(pos=(interval_end+dots_found+1);pos<=new_length;pos++) {
	g_sequence_data_new[seq][pos-dots_found]=g_sequence_data_new[seq][pos];
      }
    }
  }
  return deletes+deletes_left;
}

int clean_inserts2_find_interval(int new_length) {
  /* find single base within single sequence,
   * find inserts to left of it, move the sequence length
   * to remove inserts
   * If no inserts left, check right, do the same 
   */
 int interval_start,interval_end;
 int deletes;
 int pos;
 int which_sequence = 1, current_which_sequence = 1;
 /* which sequence is the sequence with a string of single basees */
 interval_start=-1;
 interval_end=-1;
 pos=0;
 while(pos<new_length) {
   if(interval_start<0) {
     which_sequence=single_base_found(pos);
     if(which_sequence>0) {
       current_which_sequence=which_sequence;
       interval_start=pos;
       pos++;
     } else
       pos++;
   } else {
     which_sequence=single_base_found(pos);
     if(which_sequence!=current_which_sequence) { /* zero here is no sequ */
       interval_end=pos-1;
       deletes=remove_single_bases2(interval_start,interval_end,new_length,
                                    current_which_sequence);
       pos=pos-deletes+1;
       new_length=new_length-deletes;
       interval_start=-1;
     } else
       pos++;
   }
 }
 /* process an interval at the end of the sequences */
  if(interval_start>=0) {
    interval_end=new_length-1;
    deletes=remove_single_bases2(interval_start,interval_end,new_length,
				 current_which_sequence);
    pos=pos-deletes+1;
    new_length=new_length-deletes;
    interval_start=-1;
  }
  return new_length;
}

void clean_inserts2(void) {
  /* improved version of clean_inserts first store old sequence slides
   * sequences together where single bases exist in each */ 
  int sequence;
  int new_length;
  /* store previous in previous2 */ 
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence],
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* copy current to previous */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence], g_sequence_data[sequence]);
  }
  g_sequence_length_previous=g_sequence_length;
  new_length=g_sequence_length;
  /* remove duplicates copy sequences to new */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_new[sequence], g_sequence_data[sequence]);
  }
  new_length=clean_inserts2_find_interval(new_length);
  printf("The number of inserts removed is %d\n",g_sequence_length-new_length);
  create_align_file(new_length,FALSE);
  restart_program(new_length);
}

void clean_inserts_no_base(void) {
  /* removes positions with only inserts first store old sequence */
  int sequence;
  int new_length;
  printf("Trying to remove inserts where common to all sequences.\n");
  /* store previous in previous2 */ 
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous2[sequence],
	   g_sequence_data_previous[sequence]);
  }
  g_sequence_length_previous2=g_sequence_length_previous;
  /* copy current to previous */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_previous[sequence],
	   g_sequence_data[sequence]);
  }
  g_sequence_length_previous=g_sequence_length;
  new_length=g_sequence_length;
  /* remove duplicates copy sequences to new */
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_new[sequence], g_sequence_data[sequence]);
  }
  new_length=remove_duplicates(0,new_length);
  create_align_file(new_length,FALSE);
  restart_program(new_length);
}

void redo_with_new_count(void) {
  int sequence;
  for(sequence=2;sequence<=g_last_used_sequence;sequence++) {
    strcpy(g_sequence_data_new[sequence],
	   g_sequence_data[sequence]);
  }
  restart_program(g_sequence_length);
}

void write_nearby_helix_basepair(int row,int column, int sequence) {
  int energy;
  if((row<1)||(column<1)||(row>g_sequence_length)||(column>g_sequence_length))
    return;
  if(column<=row)
    return;
  energy=energy_read(row,column,sequence);
  if((energy!=0)&&(energy<=g_energy_cutoff[sequence])) {
    energy=energy_read(row,column,g_primary_sequence);
    if((energy==0)||(energy>g_energy_cutoff[g_primary_sequence]))
      fprintf(nfp,"%5d %5d\n",row,column);
    g_count_nearby++;
  }
}

void write_nearby_helix(int sequence,int location,int distance) {
  int start_row,start_column;
  int length;
  int i;
  int d;
  int row,column;
  length=g_diag[location].length;
  start_row=g_diag[location].row;
  start_column=g_diag[location].column;
  /* for distances > 0 write dots, starting at top left, going counter
   * clockwise around the helix */ 
  for(d=1;d<=distance;d++) { /* top left corner */
    row=start_row-d;
    column=start_column+d;
    write_nearby_helix_basepair(row,column,sequence);
    /* top row, coming left */
    for(i=1;i<=(2*d);i++) {
      column--;
      write_nearby_helix_basepair(row,column,sequence);
    }
    /* left side, diagonal */
    for(i=1;i<=(length-1);i++) {
      row++;
      write_nearby_helix_basepair(row,column,sequence);
      column--;
      write_nearby_helix_basepair(row,column,sequence);
    }
    /* down to bottom left corner */
    for(i=1;i<=(2*d);i++) {
      row++;
      write_nearby_helix_basepair(row,column,sequence);
    }
    /* go across bottom */
    for(i=1;i<=(2*d);i++) {
      column++;
      write_nearby_helix_basepair(row,column,sequence);
    }
    /* go up right diagonal */
    for(i=1;i<=(length-1);i++) {
      row--;
      write_nearby_helix_basepair(row,column,sequence);
      column++;
      write_nearby_helix_basepair(row,column,sequence);
    }
    /* go up to top right corner */
    for(i=1;i<=(2*d-1);i++) {
      row--;
      write_nearby_helix_basepair(row,column,sequence);
    }
  }
}

void write_nearby(int sequence,int distance) {
  int seq,location;
  for(location=0;location<g_helices_used;location++) {
    seq=g_diag[location].color;
    if(seq==g_primary_sequence) {
      write_nearby_helix(sequence,location,distance);              
    }
  }
}

void create_nearby(int sequence,int distance) {
  int error;
  char action[250];
  char nearby_file[120];
  if(distance<1)
    return;
  if(g_count_nearby>0) {
    g_count_nearby=0;
    free(g_nearby_basepair);
  }
  /* open file */
  strcpy(nearby_file,PROGRAM_NAME".tmp");
  g_count_nearby=0;
  if(open_neighbor(nearby_file))
    return;
  write_nearby(sequence,distance);
  /* close file */
  fclose(nfp);
  /* sort the file by rows, columns */  
  strcpy(action,"sort -u -o ");
  strcat(action,nearby_file); 
  strcat(action," ");
  strcat(action,nearby_file); 
  strcat(action,"\n");
  error=system(action);
  if(error!=0) {
    printf("Error!\tSorting %s from %s. Action was %s\n",
	   nearby_file, PROGRAM_NAME, action);
    g_count_nearby=0;
    g_nearby_distance=0;
    return;
  }
  /* set up for display of nearby */
  if(g_count_nearby==0) {
    printf("No base pairs within given distance.\n");
    return;
  }
  g_nearby_basepair =
    (struct basepair *)malloc(sizeof(struct basepair)*g_count_nearby);
  g_count_nearby=0;
  /* open file for reading */
  if(g_nearby_basepair==NULL) {
    printf("Error!\tInsufficient memory for displaying nearby base pair.\n");
    return;
  }
  if(open_neighbor_r(nearby_file)) {
    printf("Strange error reading file of nearby file.\n"); 
    return;
  }
  while(fscanf(nfp,"%d %d", &g_nearby_basepair[g_count_nearby].row,
	       &g_nearby_basepair[g_count_nearby].column)==2) {
    g_count_nearby++;
  }
  printf("%d close dots found\n",g_count_nearby);
  fclose(nfp);
}

int find_base_color(char c) {
  int color; 
  c=toupper(c);
  if (c=='T') {
    c='U';     
    color=COLOR_U;
  }
  else if (c=='A')
    color=COLOR_A;
  else if (c=='C')
    color=COLOR_C;
  else if (c=='G')
    color=COLOR_G;
  else if (c=='U')
    color=COLOR_U;
  else if (c=='.')
    color=COLOR_DOT;
  else
    color=COLOR_ELSE;
  return color;
}
