
#include <time.h>  

FILE *postfp;  /* for postscript file or label file */


int open_post(char *post_filename) {  
  if ((postfp = fopen(post_filename, "w")) == NULL) {
    printf ("Error!\tCould not open file: %s.\n", post_filename);
    return(1);
  }
  return (0); 
}

void fixcolor_plot_postscript_define(float l_color[][3]) {
  int color;
  fprintf(postfp,"\n%s Set colors","%%");
  fprintf(postfp,"\n%s 0 is full overlap, 1 is partial overlap","%%");
  fprintf(postfp,"\n%s 2 is sequence 1, 3-6 are sequences 2-5","%%");
  fprintf(postfp,"\n%s 7 compensating B.P, 8 is text, 9 is grid","%%");
  fprintf(postfp,"\n%s 10 is labels and neighbors, 11 is background","%%");
  fprintf(postfp,"\n%s 12 is close dots, 13 is A, 14 is C,15 is G, 16 is U",
	  "%%");
  fprintf(postfp,"\n%s 17 is strange base, 18 is dot\n","%%");
  fprintf(postfp,"\n%s 13-18 are backgrounds, 19 is text on them\n","%%");
  fprintf(postfp,"\n%s Values come from complot.col\n","%%");
  for(color=0;color<TOTAL_COLORS;color++) {
    fprintf(postfp,"/color_%d {  %.3f %.3f %.3f setrgbcolor} def \n",color,
	    l_color[color][0],l_color[color][1],l_color[color][2]);
  } 
}

void fixcolor_plot_ann_postscript_define(float a_color[][3],
					 int ann_number_colors) {
  int color;
  fprintf(postfp,"\n%s Set colors ann 0 to maximum","%%");
  fprintf(postfp,"\n%s Values come from annotation.col\n","%%");
  for(color=0;color<ann_number_colors;color++) {
    fprintf(postfp,"/colora_%d {  %.3f %.3f %.3f setrgbcolor} def \n",color,
	    a_color[color][0],a_color[color][1],a_color[color][2]);
  } 
}

void fixcolor_plot_postscript(int color) {
  if((color>=0)&&(color<TOTAL_COLORS))
    fprintf(postfp,"\n  color_%d\n",color); 
}

int g_post_ann_num_colors;

void fixcolor_plot_ann_postscript(int color) {
  if((color>=0)&&(color<g_post_ann_num_colors))
    fprintf(postfp,"\n  colora_%d\n",color); 
}

void fix_dot_size_def1(int i,float hscale,float vscale,int big_dots_flag,
                       float ps_dot_min[][2]) {
  float dot_size,new_scale;
  if(big_dots_flag==TRUE) {
    new_scale=(hscale+vscale)/2.0;
    dot_size=ps_dot_min[i][0];
    if(new_scale*dot_size<ps_dot_min[i][1])
      dot_size=ps_dot_min[i][1]/new_scale;
  } else
    dot_size=1.0;
  fprintf(postfp,"/s%d { %.3f } def\n",i,dot_size);
}

void fix_dot_size_def2(int i) {
  fprintf(postfp,"/S%d {.50 s%d mul } def\n",i,i);
  fprintf(postfp,"/NS%d {-1.0 S%d mul } def\n",i,i);
}

void fix_dot_size(int i) {
  fprintf(postfp,"/b%d {\n",i);
  fprintf(postfp," exch len exch sub 1 add \n");
  fprintf(postfp," moveto\n");
  fprintf(postfp," S%d S%d rlineto\n",i,i);  
  fprintf(postfp,"   NS%d   0 rlineto\n",i);
  fprintf(postfp,"  NS%d NS%d rlineto\n",i,i);
  fprintf(postfp,"   0   NS%d  rlineto\n",i);
  fprintf(postfp,"   S%d    0 rlineto\n",i);
  fprintf(postfp,"   S%d S%d rlineto\n",i,i);
  fprintf(postfp,"   0    S%d  rlineto\n",i);
  fprintf(postfp,"   closepath\n");
  fprintf(postfp,"   fill\n");
  fprintf(postfp,"   stroke\n");
  fprintf(postfp,"}def\n");
}

void fix_dot_size_multicolor(int i) {
  fprintf(postfp,"/ns%d {-1.0 s%d mul} def\n",i,i);
  fprintf(postfp,"/zb%d {\n",i);
  fprintf(postfp,"/y exch def");
  fprintf(postfp," exch len exch sub 1 add \n");
  fprintf(postfp," newpath\n");
  fprintf(postfp," moveto\n");
  fprintf(postfp," .5 s%d mul .5 s%d mul rlineto\n",i,i);  
  fprintf(postfp," -.5 y sub s%d mul -.5 y add s%d mul rlineto\n",i,i);
  fprintf(postfp," y .5 sub s%d mul y .5 add ns%d mul rlineto\n",i,i);
  fprintf(postfp," .5 y add s%d mul .5 y sub s%d mul rlineto\n",i,i);
  fprintf(postfp," .5 y sub s%d mul .5 y add s%d mul rlineto\n",i,i);
  fprintf(postfp,"   closepath\n");
  fprintf(postfp,"   fill\n");
  fprintf(postfp,"   stroke\n");
  fprintf(postfp,"}def\n");
}

void display_zoom_bases_hor_ps(float hscale,int last_used_sequence,
			       int base_color_mode,int display_l,int display_r,
			       int *sequence_data_same,
			       char *sequence_data[TOTAL_SEQUENCES]) {
  int i,black,sequence;
  char c;
  int last_color;
  int current_color;
  float y;
  float x;
  float ver_offset;
  int count_sequences;
  count_sequences=last_used_sequence-1;
  fixcolor_plot_postscript(COLOR_TEXT); 
  fprintf(postfp," /Helvetica findfont\n");
  fprintf(postfp," 8 scalefont\n");
  fprintf(postfp," setfont\n");
  if(count_sequences<3)
    ver_offset=5-8*count_sequences;
  else
    ver_offset=-11;
  if(!base_color_mode) {
    for(sequence=2;sequence<=last_used_sequence;sequence++) {
      fixcolor_plot_postscript(sequence);
      for(i=display_l;i<=display_r;i++) {
	black=sequence_data_same[i];
	if(!black) {
	  y=ver_offset-(sequence-2)*8;
	  x=(i-display_l+1)*hscale-3;
	  fprintf(postfp,"%.1f %.1f \n",x-hscale/2.0+2.5,y-.8);
	  fprintf(postfp,"%.1f %.1f \n",hscale,7.8);
	  fprintf(postfp,"rectfill\n");
	}
      }
    }
  } else {
    last_color=find_base_color('A');
    fixcolor_plot_postscript(last_color);
    for(sequence=2;sequence<=last_used_sequence;sequence++) {
      for(i=display_l;i<=display_r;i++) {
	c=sequence_data[sequence][i-1];
	current_color=find_base_color(c);
	if (current_color!=last_color) {
	  last_color=current_color;
          fixcolor_plot_postscript(current_color);
	}
        y=ver_offset-(sequence-2)*8;
        x=(i-display_l+1)*hscale-3;
        fprintf(postfp,"%.1f %.1f \n",x-hscale/2.0+2.5,y-.8);
        fprintf(postfp,"%.1f %.1f \n",hscale,7.8);
        fprintf(postfp,"rectfill\n");
      }
    }         
   }
 /* black letters */
  fixcolor_plot_postscript(COLOR_TEXT_BACKGROUND);
  for(i=display_l;i<=display_r;i++) {
    for(sequence=2;sequence<=last_used_sequence;sequence++) {
      y=ver_offset-(sequence-2)*8;
      fprintf(postfp,"%.1f %.1f moveto",(i-display_l+1)*hscale-3 ,y);
      c=sequence_data[sequence][i-1];
      fprintf(postfp," (%c) show\n",c);             
    }
  }
}

void display_zoom_bases_ver_ps(float vscale,int last_used_sequence,
			       int base_color_mode,int display_t,int display_b,
			       int *sequence_data_same,
			       char *sequence_data[TOTAL_SEQUENCES],
			       int count_sequences) {
  int i,black,sequence;
  char c;
  float x;
  float y;
  float hor_offset;
  int current_color;
  int last_color;
  fixcolor_plot_postscript(COLOR_TEXT);
  fprintf(postfp," /Helvetica findfont\n");
  fprintf(postfp," 8 scalefont\n");
  fprintf(postfp," setfont\n");
  if(count_sequences<3)
    hor_offset=-14;
  else
    hor_offset=-14-(count_sequences-2)*7;
   /* do non-black */
  if(!base_color_mode) {
    for(sequence=2;sequence<=last_used_sequence;sequence++) {
      fixcolor_plot_postscript(sequence);
      for(i=display_t;i<=display_b;i++) {
	black=sequence_data_same[i]; 
	if(!black) {
	  x=hor_offset+(sequence-2)*7;
	  y=(display_b-i+1)*vscale-2.3;
	  fprintf(postfp,"%.1f %.1f \n",x-.5,y-vscale/2.0+3.0);
	  fprintf(postfp,"%.1f %.1f \n",7.0,vscale);
	  fprintf(postfp,"rectfill\n");
	}
      }
    }
  } else {
    last_color=find_base_color('A');
    fixcolor_plot_postscript(last_color);
    for(sequence=2;sequence<=last_used_sequence;sequence++) {
      for(i=display_t;i<=display_b;i++) {
	c=sequence_data[sequence][i-1];
	current_color=find_base_color(c);
	if(current_color!=last_color) {
	  last_color=current_color;
          fixcolor_plot_postscript(current_color);
	}
	x=hor_offset+(sequence-2)*7;
        y=(display_b-i+1)*vscale-2.3;
        fprintf(postfp,"%.1f %.1f \n",x-.5,y-vscale/2.0+3.0);
        fprintf(postfp,"%.1f %.1f \n",7.0,vscale);
        fprintf(postfp,"rectfill\n");
      }
    }
  }
  /* put black letters on top */ 
  fixcolor_plot_postscript(COLOR_TEXT_BACKGROUND);
  for(i=display_t;i<=display_b;i++) {
    for(sequence=2;sequence<=last_used_sequence;sequence++) {
      x=hor_offset+(sequence-2)*7;
      fprintf(postfp,"%.1f %.1f moveto",x,(display_b-i+1)*vscale-2.3);
      c=sequence_data[sequence][i-1];
      fprintf(postfp," (%c) show\n",c);
    }
  }
}

void draw_diagonal_line_post(int display_l,int display_r,int display_t,
			     int display_b) {
  int left,top,bottom,right;
  if((display_r>=display_t)&&(display_b>=display_l)) {
    top=display_t;
    bottom=display_b;
    right=display_r;
    left=display_l;
    if(display_r>=display_b) {
      bottom=display_b;
      right=display_b;
    } else {
      right=display_r;
      bottom=display_r;
    }
    if(display_l>=display_t) {
      left=display_l;
      top=display_l;
    } else {
      top=display_t;
      left=top;
    }   
    fprintf(postfp,"\n %.2f  %.2f moveto\n",
	    left-display_l+0.0, display_b-top+2.0);
    fprintf(postfp,"\n %.2f %.2f  lineto stroke\n",
	    right-display_l+2.0,display_b-bottom+0.0);
  }
}

void draw_diagonal_line_post_main(int sequence_length) {
   fprintf(postfp,"\n %.2f  %.2f moveto", 1.0, sequence_length+2.0);
   fprintf(postfp,"\n %.2f %.2f  lineto stroke", sequence_length+2.0,1.0);
}

void single_hor_tic_post(int j_col,float scale,int grid_flag) {
  fprintf(postfp," %f 1. scale\n",scale);
  fprintf(postfp,"\n\n %f setlinewidth",0.40/scale);
  fprintf(postfp," %d 540 moveto\n",j_col+1);
  fprintf(postfp," 0 8 rlineto\n");
  if(grid_flag==TRUE) {
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_GRID);
    fprintf(postfp,"\n %d 530 moveto",j_col+1);
    fprintf(postfp,"\n 0 -538 rlineto");
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_TEXT);
  }
  fprintf(postfp," %d 550 moveto\n",j_col+1);
  fprintf(postfp," %f 1. scale\n",1./scale);
  fprintf(postfp,"\n -6 0 rmoveto");
  fprintf(postfp," (%d) show\n",j_col);
}

void plot_hor_tics_post(float scale,int sequence_length,int grid_flag) { 
  int start,j_col,step;
  step=step_fun(1,sequence_length);
  start=start_fun(1,step);
  single_hor_tic_post(sequence_length,scale,FALSE);
  single_hor_tic_post(1,scale,FALSE);
  for(j_col=start;j_col<(sequence_length-2*step/3);j_col=j_col+step) {
    single_hor_tic_post(j_col,scale,grid_flag);
  }
}

void single_ver_tic_post(int i_row, float scale, int grid_flag,
			 int sequence_length) {
  fprintf(postfp," 1.0 %f scale\n",scale); 
  fprintf(postfp,"\n\n %f setlinewidth",0.40/scale);
  fprintf(postfp," 540.5 %d moveto\n",sequence_length-i_row+2);
  fprintf(postfp," 8 0 rlineto\n");
  if(grid_flag==TRUE) {
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_GRID);
    fprintf(postfp,"\n 539.5 %d moveto",sequence_length-i_row+2);
    fprintf(postfp,"\n -538 0 rlineto");
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_TEXT);
  }
  fprintf(postfp," 550.5 %d moveto\n",sequence_length-i_row+2);
  fprintf(postfp," 1.0 %f scale\n",1./scale);
  fprintf(postfp," (%d) show\n",i_row);
}

void plot_ver_tics_post(float scale,int sequence_length,int grid_flag) {
  int i_row,step,start;
  step=step_fun(1,sequence_length);
  start=start_fun(1,step);
  single_ver_tic_post(1,scale,FALSE,sequence_length);
  single_ver_tic_post(sequence_length,scale,FALSE,sequence_length);
  for(i_row=start;i_row<(sequence_length-step/2);i_row=i_row+step) {
    single_ver_tic_post(i_row,scale,grid_flag,sequence_length);
  }
}

void single_hor_tic_zoom_post(int j_col, float scale, int grid_flag,
			      int hor_bases, int display_l,
			      int count_sequences) {
  float top_edge;
  if(!hor_bases)
    top_edge=540.0;
  else
    top_edge=540-8*count_sequences;
  fprintf(postfp," %f 1. scale\n",scale); 
  fprintf(postfp,"\n\n %.2f setlinewidth",0.70/scale);
  fprintf(postfp," %d %.2f moveto\n",j_col-display_l+1,top_edge+1);
  fprintf(postfp," 0 8 rlineto\n");
  if(grid_flag==TRUE) {
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_GRID);
    fprintf(postfp,"\n %d %.2f moveto",j_col-display_l+1,top_edge-1);
    fprintf(postfp,"\n 0 %.2f rlineto",-1*(top_edge-1));
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_TEXT);
  }
  fprintf(postfp," %d %.2f moveto\n",j_col-display_l+1,top_edge+10);
  fprintf(postfp," %f 1. scale\n",1./scale);
  fprintf(postfp," -6 0 rmoveto\n");
  fprintf(postfp," ( %d ) show\n",j_col);
}

void plot_hor_tics_zoom_post(float scale, int hor_bases, int display_l,
			     int display_r, int grid_flag, 
			     int count_sequences) { 
  int j_col,step;
  int start;
  step=step_fun(display_l,display_r);
  start=start_fun(display_l,step);
  single_hor_tic_zoom_post(display_r,scale,FALSE,hor_bases,display_l,
			   count_sequences);
  single_hor_tic_zoom_post(display_l,scale,FALSE,hor_bases,display_l,
			   count_sequences);
  for(j_col=start;j_col<(display_r-2*step/3); j_col=j_col+step) {
    single_hor_tic_zoom_post(j_col, scale, grid_flag, hor_bases,
			     display_l, count_sequences);
  }
}

void single_ver_tic_zoom_post(int i_row, float scale, int grid_flag,
			      int ver_bases, int display_b) {
  float right_edge;
  if(ver_bases)
    right_edge=519.5;
  else
    right_edge=540.5;
  fprintf(postfp," 1. %f scale\n",scale);
  fprintf(postfp," %.2f %d moveto\n",right_edge,display_b-i_row+1);
  fprintf(postfp,"\n\n %f setlinewidth",0.70/scale);
  fprintf(postfp," 10 0 rlineto\n");
  if(grid_flag==TRUE) {
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_GRID);
    fprintf(postfp,"\n %.2f %d moveto",right_edge-1,display_b-i_row+1);
    fprintf(postfp,"\n %.2f 0 rlineto",-1*(right_edge-1));
    fprintf(postfp,"\n stroke");
    fixcolor_plot_postscript(COLOR_TEXT);
  }
  fprintf(postfp," %.2f %d moveto\n",right_edge+10,display_b-i_row+1);
  fprintf(postfp," 1. %f scale\n",1./scale);
  fprintf(postfp," ( %d ) show\n",i_row);
}

void plot_ver_tics_zoom_post(float scale, int ver_bases, int display_t,
			     int display_b, int grid_flag) {
  int i_row,step,start;
  step=step_fun(display_t,display_b);
  start=start_fun(display_t,step);
  single_ver_tic_zoom_post(display_t,scale,FALSE,ver_bases,display_b);
  single_ver_tic_zoom_post(display_b,scale,FALSE,ver_bases,display_b);
  for(i_row=start;i_row<(display_b-step/2);i_row=i_row+step) {
    single_ver_tic_zoom_post(i_row, scale, grid_flag, ver_bases, display_b);  
  }
}

void draw_postscript_dots_main_comp(int last_diagonal, int *diag_count,
				    int *diag_start, struct helix *l_diag,
				    int unique_mode, int dot_lower_flag,
				    int annotation_flag,
				    int prob_annotation_flag) {
  int row,col,new_row,count;
  int diag,position,location,new_color;
  int color; 
  fixcolor_plot_postscript(COLOR_COMP);
  color=0;
  for(diag=2;diag<=last_diagonal;diag++) {
    position=diag_start[diag];
    for(count=0;count<diag_count[diag];count++) {
      location=position+count;
      new_color=l_diag[location].color;
      if(new_color==color) {
	new_row=l_diag[location].row;
	col=l_diag[location].column;
	for(row=new_row; row<(new_row+l_diag[location].length);row++) {
	  if(check_compensate(row,col)) {
	    if(!unique_mode) {
	      if(!dot_lower_flag)
		fprintf(postfp,"%d %d b7\n",row-1,col+1);
	      else
		fprintf(postfp,"%d %d b7\n",col-1,row+1);
	    }
	    if((!annotation_flag)&&(!prob_annotation_flag)) {
	      if(!dot_lower_flag)
		fprintf(postfp,"%d %d b7\n",col-1,row+1);
	      else
		fprintf(postfp,"%d %d b7\n",row-1,col+1);
	    }
	  }
	  col--;
	}                        
      }
    }
  }
}

void draw_postscript_dots_main_unique(int sequence_length, int last_diagonal,
				      struct helix *l_diag, int *diag_count,
				      int *diag_start, int dot_lower_flag) {
  int row,col,new_row,count;
  int diag,position,location;
  int size,current_color,start_diag,end_diag;
  int *holder; 
  holder=malloc((int)(1.5*sequence_length+1)*sizeof(int));
  if(holder==NULL) {
    printf("Error!\tInsufficient memory for unique dots ");
    printf("within plot_points_unique of %s\n.", PROGRAM_NAME);
    try_exit(28);
  }
  size=(int)(1.5*sequence_length+1);
  for(row=0; row<(size-1); row++) 
    holder[row]=0;
  current_color=2;
  fixcolor_plot_postscript(2);
  start_diag=1+1-1;
  end_diag=last_diagonal;
  /* set black,gray */
 for(diag=start_diag;diag<=end_diag;diag++) {  /* set black,gray */
   position=diag_start[diag];
   for(count=0;count<diag_count[diag];count++) {
     location=position+count;
     if(l_diag[location].color<2) {
       new_row=l_diag[location].row;
       col=l_diag[location].column;
       for(row=new_row;row<new_row+l_diag[location].length;row++) {
	 holder[row]=1;
	 col--;
       }
     }
   }
   /* plot other colors */
   for(count=0;count<diag_count[diag];count++) {
     location=position+count;
     if(l_diag[location].color>1) {
       if(current_color!=l_diag[location].color) {
	 current_color=l_diag[location].color;
	 fixcolor_plot_postscript(current_color);
       }
       for(row=l_diag[location].row, col=l_diag[location].column;
	   row<l_diag[location].row+l_diag[location].length; row++) {
	 if(holder[row]==0) {
	   if(!dot_lower_flag)
	     fprintf(postfp,"%d %d b%d\n",row-1,col+1,current_color);
	   else
	     fprintf(postfp,"%d %d b%d\n",col-1,row+1,current_color);
	 }
	 col--;
       }
     }
   }
   /* zero out black,gray */
   for(count=0;count<diag_count[diag];count++) {           
     location=position+count;
     if(l_diag[location].color<2) {
       new_row=l_diag[location].row;
       col=l_diag[location].column;
       for(row=new_row;row<new_row+l_diag[location].length;row++) {
	 holder[row]=0;
	 col--;
       }
     }
   }
 }
 free(holder);
}

void draw_postscript_dots_main_close(int count_nearby, 
				     struct basepair* nearby_basepair) {
  /* plot the dots with the close distance specified */
  int i,row,col;
  fixcolor_plot_postscript(COLOR_CLOSE);
  for(i=0;i<count_nearby;i++) {
    row=nearby_basepair[i].row;
    col=nearby_basepair[i].column;
    fprintf(postfp,"%d %d b%d\n",row-1,col+1,1);
    fprintf(postfp,"%d %d b%d\n",col-1,row+1,1);
  }                       
}

int get_ann_color(int,int);

void draw_postscript_dots_main(int last_used_sequence, int last_diagonal,
			       int *diag_count, int *diag_start, 
			       struct helix *l_diag, int unique_mode,
			       int count_nearby, 
			       struct basepair *nearby_basepair, int comp_flag,
			       int sequence_length, int dot_lower_flag,
			       int no_partial_flag, int annotation_flag,
			       int prob_annotation_flag) {
  int row,col,new_row,count;
  int diag,position,location,new_color;
  int color,seq; 
  int ann_color;
  for(color=last_used_sequence;color>=0;color--) {
    if((color==1)&&(count_nearby>0))
      draw_postscript_dots_main_close(count_nearby,nearby_basepair);
    fixcolor_plot_postscript(color);
    for(diag=2;diag<=last_diagonal;diag++) {
      position=diag_start[diag];
      for(count=0;count<diag_count[diag];count++) {
	location=position+count;
        seq=l_diag[location].color;
	new_color=l_diag[location].color;
	if(new_color==color) {
	  new_row=l_diag[location].row;
	  col=l_diag[location].column;
	  for(row=new_row; row<(new_row+l_diag[location].length);row++) {
	    if(seq==0) {
	      if((annotation_flag)||(prob_annotation_flag)) {
		ann_color=get_ann_color(row,col);
		fixcolor_plot_ann_postscript(ann_color);
	      }
	      if(!dot_lower_flag)
		fprintf(postfp,"%d %d b%d\n",col-1,row+1,color);
	      else
		fprintf(postfp,"%d %d b%d\n",row-1,col+1,color);
	      fixcolor_plot_postscript(seq);
	    }
	    if((seq==1)&&(!no_partial_flag)) {
	      if(!dot_lower_flag)
		fprintf(postfp,"%d %d b%d\n",col-1,row+1,color);
	      else
		fprintf(postfp,"%d %d b%d\n",row-1,col+1,color);
	    }
	    if(!unique_mode) {
	      if(!dot_lower_flag)
		fprintf(postfp,"%d %d b%d\n",row-1,col+1,color);
	      else
		fprintf(postfp,"%d %d b%d\n",col-1,row+1,color);
	    }
	    col--;
	  }                        
	}
      }
    }
  }
 if(comp_flag)
   draw_postscript_dots_main_comp(last_diagonal, diag_count, diag_start,
				  l_diag, unique_mode, dot_lower_flag,
				  annotation_flag, prob_annotation_flag);
 if(unique_mode)
   draw_postscript_dots_main_unique(sequence_length, last_diagonal,
				    l_diag, diag_count, diag_start,
				    dot_lower_flag);
}

void draw_postscript_dots_zoom_compensate(int display_l,int display_r,
					  int display_t,int display_b,
					  int *diag_count,int *diag_start,
					  struct helix *l_diag,
					  int dot_lower_flag) {
  int row,col,new_row,count;
  int diag,position,location,new_color;
  int color; 
  int start_diag;
  int end_diag; 
  start_diag=display_t+display_l-1;
  end_diag=display_b+display_r-1;
  color=0;
  fixcolor_plot_postscript(COLOR_COMP);
  for(diag=start_diag;diag<=end_diag;diag++) {
    position=diag_start[diag];
    for(count=0;count<diag_count[diag];count++) {
      location=position+count;
      new_color=l_diag[location].color;
      if(new_color==color) {
	new_row=l_diag[location].row;
	col=l_diag[location].column;
	for(row=new_row; row<(new_row+l_diag[location].length);row++) {
	  if((row>=display_t)&&(row<=display_b)
	     &&(col>=display_l)&&(col<= display_r)) {
	    if(check_compensate(row,col)) {
	      if(!dot_lower_flag)
		fprintf(postfp,"%d %d b7\n", row-display_t+1,col-display_l+1);
	      else
		fprintf(postfp,"%d %d b7\n", col-display_l+1,row-display_t+1);
	    }
	  }
	  col--;        
	}
      }
    }
  }
}

void draw_postscript_dots_zoom_close(int display_l,int display_r,int display_t,
				     int display_b,int count_nearby,
				     struct basepair *nearby_basepair) {
  /* plot the dots with the close distance specified */
  int i,row,col;
  fixcolor_plot_postscript(COLOR_CLOSE);
  for(i=0;i<count_nearby;i++) {
    row=nearby_basepair[i].row;
    col=nearby_basepair[i].column;
    if( (row>=display_t) && (row<=display_b) && (col>=display_l)
	&& (col<=display_r) )
      fprintf(postfp,"%d %d b%d\n", row-display_t+1,col-display_l+1,1);
    /* lower triangle */
    if( (col>=display_t) && (col<=display_b) && (row>=display_l)
	&& (row<=display_r) )
      fprintf(postfp,"%d %d b%d\n", col-display_t+1,row-display_l+1,1);
  }
}


void draw_postscript_dots_zoom(int sequence_length,int last_used_sequence,
           int display_l,int display_r,int display_t,int display_b,
           int *diag_count,int *diag_start,struct helix *l_diag,
           int count_nearby,int unique_mode,int comp_flag,int count_neighbors,
           int *neighbor_keeper_row,int *neighbor_keeper_column,
           struct basepair* nearby_basepair,int dot_lower_flag,
           int multicolor_dots_flag,
           int no_partial_flag,int annotation_flag,int prob_annotation_flag) {
  int row,col,new_row,count;
  int diag,position,location,new_color;
  int color;
  int start_diag;
  int end_diag; 
  int size,current_color;
  int *holder;
  int ann_color;
  float size_dot = 0.5;
  char dot_type[3];
  int dl_display_t,dl_display_b,dl_display_r,dl_display_l;
  if(dot_lower_flag) {
    dl_display_t=display_l;
    dl_display_b=display_r;
    dl_display_l=display_t;
    dl_display_r=display_b;
  }
  else {
    dl_display_t=display_t;
    dl_display_b=display_b;
    dl_display_l=display_l;
    dl_display_r=display_r;
  }
  if(multicolor_dots_flag)
    strcpy(dot_type,"zb");
  else
    strcpy(dot_type,"b");
  start_diag=display_t+display_l-1;
  end_diag=display_b+display_r-1;
  /* normal mode all dots in upper triangle */
  if(!unique_mode) {
    for(color=last_used_sequence;color>=0;color--) {
      if((color==1)&&(count_nearby>0))
	draw_postscript_dots_zoom_close(display_l,display_r,display_t,
					display_b,count_nearby,
					nearby_basepair);
      if(multicolor_dots_flag) {
	if(color==1) { /* skip gray dots */
          color--;
	  size_dot=.5;
	} else {
	  if(color>1)
            size_dot=(color-1.)/(last_used_sequence-1.)*.5;
	  else
            size_dot=.5; /* it might be hard to hit this line */           
	}
      }       
      fixcolor_plot_postscript(color);
      for(diag=start_diag;diag<=(end_diag);diag++) {
	position=diag_start[diag];
	for(count=0;count<diag_count[diag];count++) {
	  location=position+count;
	  new_color=l_diag[location].color;
	  if(new_color==color) {
	    new_row=l_diag[location].row;
	    col=l_diag[location].column;
	    for(row=new_row; row<(new_row+l_diag[location].length);row++) {
	      if((row>=dl_display_t)&&(row<=dl_display_b)
		 &&(col>=dl_display_l)&&(col<=dl_display_r)) {
		if(multicolor_dots_flag) {
		  if(!dot_lower_flag)
		    fprintf(postfp,"%d %d %.4f zb%d\n",row-dl_display_t+1,
			    col-dl_display_l+1,size_dot, color);
		  else
		    fprintf(postfp,"%d %d %.4f zb%d\n", col-dl_display_l+1,
			    row-dl_display_t+1,size_dot, color);
		} else {
		  if(!dot_lower_flag)
		    fprintf(postfp,"%d %d b%d\n", row-dl_display_t+1,
			    col-dl_display_l+1, color);
		  else
		    fprintf(postfp,"%d %d b%d\n", col-dl_display_l+1,
			    row-dl_display_t+1,  color);
		}
	      }
	      col--;
	    }        
	  }
        }
      }
    }
  }
  /* draw compensate in upper triangle */
  if((comp_flag)&&(!unique_mode))
    draw_postscript_dots_zoom_compensate(dl_display_l,dl_display_r,
					 dl_display_t,dl_display_b,diag_count,
					 diag_start,l_diag, dot_lower_flag);
  /* draw lower triangle */
  for(color=1;color>=0;color--) {
    if(no_partial_flag)
      color=0;
    fixcolor_plot_postscript(color);
    for(diag=start_diag;diag<=(end_diag);diag++) {
      position=diag_start[diag];
      for(count=0;count<diag_count[diag];count++) {
	location=position+count;
	new_color=l_diag[location].color;
	if(new_color==color) {
	  new_row=l_diag[location].row;
	  col=l_diag[location].column;
	  if(col>=dl_display_t) {
	    for(row=new_row; row<(new_row+l_diag[location].length);row++) {
	      if((col>=dl_display_t)&&(col<=dl_display_b)
		 &&(row>=dl_display_l)&&(row<= dl_display_r)) {
		if(((annotation_flag)||(prob_annotation_flag)) &&(color==0)) {
		  ann_color=get_ann_color(row,col);
		  fixcolor_plot_ann_postscript(ann_color);
		  if(!dot_lower_flag)
		    fprintf(postfp,"%d %d b%d\n",
			    col-dl_display_t+1,row-dl_display_l+1,color);
		  else
		    fprintf(postfp,"%d %d b%d\n",
			    row-dl_display_l+1,col-dl_display_t+1,color);
		} else {
		  if((comp_flag)&& (color==0)&& check_compensate(row,col)) {
		    fixcolor_plot_postscript(COLOR_COMP);
		    if(!dot_lower_flag)
		      fprintf(postfp,"%d %d b%d\n",
			      col-dl_display_t+1,row-dl_display_l+1,color);
		    else
		      fprintf(postfp,"%d %d b%d\n",
			      row-dl_display_l+1,col-dl_display_t+1,color);
		    fixcolor_plot_postscript(color);
		  } else {
		    if(!dot_lower_flag)
		      fprintf(postfp,"%d %d b%d\n",
			      col-dl_display_t+1,row-dl_display_l+1,color);
		    else
		      fprintf(postfp,"%d %d b%d\n",
			      row-dl_display_l+1,col-dl_display_t+1,color);
		  }
		}
	      }
	      col--;
	    }        
	  }
	}
      }
    }
  }
  /* draw unique dots */
  if(unique_mode) {
    holder=malloc((int)(1.5*sequence_length+1)*sizeof(int));
    if(holder==NULL) {
      printf("Error\tInsufficiend memory for unique dots ");
      printf("within plot_points_unique of complot.\n");
      try_exit(29);
    }
    size=(int)(1.5*sequence_length+1);
    for(row=0;row<(size-1);row++)
      holder[row]=0;
    current_color=2;
    fixcolor_plot_postscript(current_color);
    /* set black,gray */
    for(diag=start_diag;diag<=end_diag;diag++) { 
      /* set black,gray */
      position=diag_start[diag];
      for(count=0;count<diag_count[diag];count++) {
	location=position+count;
	if(l_diag[location].color<2) {
	  new_row=l_diag[location].row;
	  col=l_diag[location].column;
	  if((new_row<=dl_display_b)&&(col>=dl_display_l)) {
            for(row=new_row;row<new_row+l_diag[location].length;row++) {
	      if((row>=dl_display_t)&&(row<=dl_display_b)
		 &&(col>=dl_display_l)&&(col<=dl_display_r)) {
                holder[row]=1;
	      }
	      col--;
	    }
	  }
	}
      }
      /* plot other colors */
      for(count=0;count<diag_count[diag];count++) {
	location=position+count;
        if((l_diag[location].row<=dl_display_b)&&
	   (l_diag[location].column>=dl_display_l)) {
	  if(l_diag[location].color>1)
	    for(row=l_diag[location].row, col=l_diag[location].column;
		row<l_diag[location].row+l_diag[location].length; row++) {
	      if((row>=dl_display_t)&&(row<=dl_display_b)
		 &&(col>=dl_display_l)&&(col<=dl_display_r)) {  
		if(holder[row]==0) {
		  if(current_color!=l_diag[location].color) {
		    current_color=l_diag[location].color;
		    fixcolor_plot_postscript(current_color);
		  }
		  if(!dot_lower_flag)
		    fprintf(postfp,"%d %d b%d\n", row-dl_display_t+1,
			    col-dl_display_l+1,current_color);
		  else
		    fprintf(postfp,"%d %d b%d\n", col-dl_display_l+1,
			    row-dl_display_t+1,current_color);
		}
	      }
	      col--;
	    }
	}
      }
      /* zero out black,gray */
      for(count=0;count<diag_count[diag];count++) {           
	location=position+count;
	if(l_diag[location].color<2) {
	  new_row=l_diag[location].row;
	  col=l_diag[location].column;
	  if((new_row<=dl_display_b)&& (col>=dl_display_l)) { 
	    for(row=new_row;row<new_row+l_diag[location].length;row++) {
	      if((row>=dl_display_t)&&(row<=dl_display_b) 
		 &&(col>=dl_display_l)&&(col<=dl_display_r)) {  
		holder[row]=0;
	      }
	      col--;
	    }
	  }
	}
      }
      
    }	
    free(holder);
  }
  /* draw neighbor dots plot neighbors */
  if (count_neighbors>0) {
    fixcolor_plot_postscript(COLOR_LABEL);
    for (position=0;position<count_neighbors;position++) {
      row=neighbor_keeper_row[position];
      col=neighbor_keeper_column[position];
      if( (row>=dl_display_t) && (col>=dl_display_l) && (col<=dl_display_r)
	  && (row<=dl_display_b)) {
	if(!dot_lower_flag)
	  fprintf(postfp,"%d %d sbox\n",row-dl_display_t+1,col-dl_display_l+1);
	else
	  fprintf(postfp,"%d %d sbox\n",col-dl_display_l+1,row-dl_display_t+1);
      }
    }     
  }
}

void general_post(char *post_filename, int sequence_length, int big_dot_flag,
		  int last_used_sequence, int base_color_mode, int display_l,
		  int display_r, int display_t, int display_b,
		  int *sequence_data_same,
		  char *sequence_data[TOTAL_SEQUENCES], int count_sequences,
		  int grid_flag, int last_diagonal, int *diag_count,
		  int *diag_start, struct helix *l_diag, int unique_mode,
		  int count_nearby, struct basepair *nearby_basepair,
		  int comp_flag, int count_neighbors, int *neighbor_keeper_row,
		  int *neighbor_keeper_col, int post_file, int display_w, 
		  int display_h, int *points_plotted_ind, int chain_len, 
		  int comp, int zoom_comp, char sequence_name[][120], 
		  int *worst_energy, int *optimal_energy, int *energy_cutoff,
		  int zoom_labels_count, int *zoom_labels_row, 
		  int *zoom_labels_col, char zoom_labels_string[50][15],
		  float l_color[][3], float ps_dot_min[][2], 
		  int points_plotted, int points_plotted_zoom,
		  int points_plotted_zoom_all, int dot_lower_flag,
		  int multicolor_dots_flag, int no_partial_flag,
		  int annotation_flag, int prob_annotation_flag,
		  float a_color[][3], int number_ann_colors) {
  float hscale,vscale;
  int i;
  int error;
  int ver_bases,hor_bases; 
  char str[120];
  float right_edge;
  float top_edge;
  ver_bases=FALSE;
  hor_bases=FALSE;
  if((annotation_flag)||(prob_annotation_flag))
    g_post_ann_num_colors=number_ann_colors;
  printf("Postscript file: %s\n",
	 post_filename);
  error=open_post(post_filename);
  if(error) {
    printf("\aError creating postscript file # %d",error);
    return;
  }
  if(post_file==MAIN_POST) {
    hscale=540.0/(sequence_length+2);
    /* 540 is 72*7.5 for 7.5 inches of paper */
    vscale=hscale;
  } else {
    if(display_h<100) {
      hscale=519.0/(display_w+1);
      ver_bases=TRUE;
    } else
      hscale=540.0/(display_w+1);
    if(display_w<100) {
      vscale=(540-8.*count_sequences)/(display_h+1.);
      hor_bases=TRUE;
    } else
      vscale=540.0/(display_h+1);
  }
  fprintf(postfp,"%c!PS-Adobe-3.0 EPSF-2.0 \n",'%');
  fprintf(postfp,"%sBoundingBox: 0 0 %d %d\n","%%", 612,792);
  fprintf(postfp,"%s from Postscript dotplot file \n","%%");
  fprintf(postfp,"%s Created by %s, %s\n","%%",PROGRAM_NAME, PACKAGE_STRING);
  display_time(postfp);
  fprintf(postfp,"%s\n%s\n","%%","%%");
  fprintf(postfp," %f %f scale\n",1.0,1.0);
  fprintf(postfp,"%s\n","%%");
  fprintf(postfp,"%s To change image size ....\n","%%");
  fprintf(postfp,"%s For full size image Use Bound ngBox:0 0 612 792\n","%%");
  fprintf(postfp,"%s                     and 1.0 1.0 scale\n","%%");
  fprintf(postfp,"%s For image .25 of full size, replace 612 with .25*612\n","%%");
  fprintf(postfp,"%s         replace 792 with .25*792 and replace\n","%%");
  fprintf(postfp,"%s         1.0 with .25: Other scales are similar.\n","%%");
  fprintf(postfp,"%s                Valid scales are .05 to 1.00\n","%%");
  fprintf(postfp,"%s ONLY scale and Bound ngBox lines above should be changed.\n", "%%");
  fprintf(postfp,"%s\n","%%");
  fixcolor_plot_postscript_define(l_color);
  if((annotation_flag)||(prob_annotation_flag))
    fixcolor_plot_ann_postscript_define(a_color,number_ann_colors);
  fprintf(postfp,
       "\n%s Dot shape and Size definitions, b0 is overlap, b1 partial overlap\n","%%");
    fprintf(postfp,"%s b2 is sequence 1, b3 is sequence 2, etc\n","%%");
    fprintf(postfp,"%s b7 is compensate, sbox is for labels\n","%%");
    fprintf(postfp,"\n%s Change si below to adjust size of dots\n","%%");
    fprintf(postfp,"%s sl is for labels \n","%%");
    fprintf(postfp,"%s 1.0 is no overlap, s0 = 2.0 doubles size of\n","%%");
    fprintf(postfp,"%s full overlap dots, b0\n","%%");
    fprintf(postfp,"%s s2 = 2.0 doubles size of sequence 1 dots\n","%%");
    fprintf(postfp,"%s adjust s0 for full overlap, s1 for partial, s2 for\n",
            "%%");
    fprintf(postfp,"%s sequence 1, s3 for sequence 2, s4 for 3, s5 for 4 \n","%%");
    fprintf(postfp,"%s Use %.4f to make dots 1/72 inch or 1 point\n","%%",
       2.0/(hscale+vscale));
    fprintf(postfp,"%s Ignore Si,NSi,len \n\n","%%");
    if((multicolor_dots_flag)&&(post_file!=MAIN_POST))
       fprintf(postfp,"%s zb same as b for multicolor overlap dots \n\n","%%");
  for(i=0;i<=last_used_sequence;i++) {
    fix_dot_size_def1(i,hscale,vscale,big_dot_flag,ps_dot_min);
  } 
  fix_dot_size_def1(7,hscale,vscale,big_dot_flag,ps_dot_min);
  if(post_file!=MAIN_POST) {
    fprintf(postfp,"/sl { .5 } def\n");
  }
  fprintf(postfp,"\n");
  for(i=0;i<=last_used_sequence;i++) {
    fix_dot_size_def2(i);
  }
  fix_dot_size_def2(7);
  if(post_file!=MAIN_POST) {
    fprintf(postfp,"/Sl {.50 sl mul } def\n");
    fprintf(postfp,"/NSl {-1.0 Sl mul } def\n");
  }
  fprintf(postfp,"\n");
  if(post_file==MAIN_POST)
    fprintf(postfp,"/len { %d } def\n\n",sequence_length);
  else
    fprintf(postfp,"/len { %d } def\n\n",display_h);    
  for(i=0;i<=last_used_sequence;i++) {
    fix_dot_size(i);
  }
  fix_dot_size(7); 
  if((post_file!=MAIN_POST)&&(multicolor_dots_flag)) {
    for(i=2;i<=last_used_sequence;i++) {
      fix_dot_size_multicolor(i);
    }
    fix_dot_size_multicolor(0);      
  }
  if(post_file!=MAIN_POST) {
    fprintf(postfp,"%s Box size for labels, neighbors \n","%%");
    fprintf(postfp,"/sbox {\n");
    fprintf(postfp,"  exch len exch sub 1 add \n");
    fprintf(postfp," moveto\n");
    fprintf(postfp,"   Sl  Sl rlineto\n");
    fprintf(postfp,"   NSl   0  rlineto\n");
    fprintf(postfp,"  NSl    NSl rlineto\n");
    fprintf(postfp,"   0   NSl  rlineto\n");
    fprintf(postfp,"   Sl    0 rlineto\n");
    fprintf(postfp,"   Sl  Sl  rlineto\n");
    fprintf(postfp,"   0    Sl  rlineto\n");
    fprintf(postfp,"   closepath\n");
    fprintf(postfp,"   fill\n");
    fprintf(postfp,"   stroke\n");
    fprintf(postfp,"}def\n\n");
  }
  /* create background color */
  fprintf(postfp,"\n%s Set the background color  \n","%%");
  fixcolor_plot_postscript(COLOR_BACK);
  fprintf(postfp,"\n0 0 moveto");
  fprintf(postfp,"\n611 0 rlineto");
  fprintf(postfp,"\n0 791 rlineto");
  fprintf(postfp,"\n-611 0 rlineto");
  fprintf(postfp,"\n0 -791 rlineto");
  fprintf(postfp,"\nclosepath");
  fprintf(postfp,"\nfill");
  fprintf(postfp,"\n%s Set the TITLE , and other text \n","%%");
  fixcolor_plot_postscript(COLOR_TEXT);
  fprintf(postfp," /Helvetica findfont\n");
  fprintf(postfp," 20 scalefont\n");
  fprintf(postfp," setfont\n");
  fprintf(postfp," 200 750 moveto\n");
  fprintf(postfp," ( complot ) show\n");
  fprintf(postfp," /Helvetica findfont\n");
  fprintf(postfp," 10 scalefont\n");
  fprintf(postfp," setfont\n");
  fprintf(postfp," 50 725 moveto\n"); 
  strcpy(str,"Base Pairs Plotted: ");
  if(post_file==MAIN_POST)
    strcat(str,num_string_int(points_plotted));
  else
    strcat(str,num_string_int(points_plotted_zoom));
  strcat(str,"          Common Base Pairs Plotted: ");
  if(post_file==MAIN_POST)
    strcat(str,num_string_int(points_plotted_ind[0]));
  else
    strcat(str,num_string_int(points_plotted_zoom_all));
  fprintf(postfp," ( %s ) show\n",str);
  if(chain_len>1) {
    fprintf(postfp," 390 725 moveto\n");
    strcpy(str,"Filter: ");
    strcat(str,num_string_int(chain_len));
    fprintf(postfp," (%s) show\n",str);
  }
  /* label colors and cutoff values */
  fprintf(postfp," 50 135 moveto\n");
  fprintf(postfp," ( Name ) show\n");
  if(g_prob!=TRUE) {
    strcpy(str,"Optimal      ");
    strcat(str,"  Highest          Cutoff       Energies in kcal/mol ");
  } else
    strcpy(str,
	   " Range                                      Cutoff                           ");
  fprintf(postfp," 190 135 moveto\n");
  fprintf(postfp, " ( %s ) show\n",str);
  fprintf(postfp," 25 133 moveto\n");
  fprintf(postfp," 550 0 rlineto stroke\n");
  if(comp_flag) {
    fixcolor_plot_postscript(COLOR_COMP);
    fprintf(postfp,"500 120. moveto\n");
    if(post_file==MAIN_POST)
      fprintf(postfp,"(Comp. Pairs: %d) show\n",comp);
    else
      fprintf(postfp,"(Comp. Pairs: %d) show\n",zoom_comp);
  }
  for(i=0;i<=last_used_sequence;i++) {
    fixcolor_plot_postscript(i);
    strcpy(str,sequence_name[i]);
    fprintf(postfp," 50 %d moveto \n",120-i*15);
    fprintf(postfp," ( %s ) show \n",str);
  }
  fixcolor_plot_postscript(COLOR_TEXT);
  for(i=2;i<=last_used_sequence;i++) {
    if(g_prob==TRUE) {
      strcpy(str,num_string_fancy_int(worst_energy[i]));
      strcat(str," <= Prob <= ");
      strcat(str,num_string_fancy_int(optimal_energy[i]));
      strcat(str,"           ");
      strcat(str,num_string_fancy_int(energy_cutoff[i]));
    } else {
      strcpy(str,num_string_fancy_int(optimal_energy[i]));
      strcat(str,"             ");
      strcat(str,num_string_fancy_int(worst_energy[i]));
      strcat(str,"        ");
      strcat(str,num_string_fancy_int(energy_cutoff[i]));
      strcat(str, "   or ");
      strcat(str, num_string_fancy_int(energy_cutoff[i]-optimal_energy[i]));
    }
    fprintf(postfp," 190  %d moveto\n",120-i*15);
    fprintf(postfp," ( %s ) show\n",str);
  }
  if(ver_bases) 
    fprintf(postfp," 46 150 translate\n");
  else
    fprintf(postfp," 25 150 translate\n");
  if(hor_bases)
    fprintf(postfp," 0 %d translate\n",8*count_sequences);
  /* label top and side ticks */ 
  fprintf(postfp," 0.70 setlinewidth\n");
  fprintf(postfp,"\n%s Make tick marks and grid lines  \n","%%");
  if(post_file==MAIN_POST) {
    plot_hor_tics_post(hscale,sequence_length,grid_flag);
    plot_ver_tics_post(vscale,sequence_length,grid_flag);
  } else {
    plot_hor_tics_zoom_post(hscale,hor_bases,display_l,display_r,grid_flag,
			    count_sequences);
    plot_ver_tics_zoom_post(vscale,ver_bases,display_t,display_b,grid_flag);
  }
  /* draw box or triangle */ 
  fprintf(postfp," 0.70 setlinewidth\n");
  if(ver_bases)
    right_edge=519.5;
  else
    right_edge=540.5;
  if(hor_bases)
    top_edge=540.5-8*count_sequences;
  else
    top_edge=540.5;
  /* left */
  fprintf(postfp,"%s Draw outer box  \n","%%");
  fprintf(postfp," 0 %.3f moveto 0 0 lineto stroke\n",top_edge);
  /* bottom */
  fprintf(postfp," 0 0.0 moveto %.3f 0 lineto stroke\n",right_edge);    
  /* draw top  */
  fprintf(postfp," 0 %.3f moveto %.3f %.3f lineto stroke\n",
	  top_edge,right_edge,top_edge);
  /* right */
  fprintf(postfp," %.3f 0  moveto %.3f %.3f lineto stroke\n",
	  right_edge,right_edge,top_edge);
  if(post_file!=MAIN_POST) {
    if(hor_bases) {
      fprintf(postfp,"%s Draw Horizontal bases  \n","%%");
      display_zoom_bases_hor_ps(hscale,last_used_sequence,base_color_mode,
				display_l,display_r,sequence_data_same,
				sequence_data);
      fixcolor_plot_postscript(COLOR_TEXT);
    }
    if(ver_bases) {
      fprintf(postfp,"%s Draw vertical bases  \n","%%");
      display_zoom_bases_ver_ps(vscale,last_used_sequence,base_color_mode,
				display_t,display_b,sequence_data_same,
				sequence_data,count_sequences);
      fixcolor_plot_postscript(COLOR_TEXT);
    }
  }
  fprintf(postfp," %f %f scale\n",hscale,vscale);
  fprintf(postfp,"%s Draw diagonal line, then bases  \n","%%");
  fprintf(postfp,"\n %f setlinewidth",0.7/(hscale+vscale)*2.0); 
  if(post_file==MAIN_POST) {
    draw_diagonal_line_post_main(sequence_length);
    fprintf(postfp,"%s For bases, you may adjust colors or order  \n","%%");
    fprintf(postfp,
	    "%s Currently  sequences, partial overlap, overlap  \n","%%");
    draw_postscript_dots_main(last_used_sequence,last_diagonal,diag_count,
			      diag_start,l_diag,unique_mode,count_nearby,
			      nearby_basepair,comp_flag,sequence_length,
			      dot_lower_flag, no_partial_flag,annotation_flag,
			      prob_annotation_flag);
  } else {
    draw_diagonal_line_post(display_l,display_r,display_t,display_b);
    fprintf(postfp,"%s For bases, you may adjust colors or order  \n","%%"); 
    fprintf(postfp,
	    "%s Currently sequences, partial overlap, overlap  \n","%%");
    draw_postscript_dots_zoom(sequence_length,last_used_sequence,
			      display_l,display_r,display_t,display_b,
			      diag_count,diag_start,l_diag,count_nearby,
			      unique_mode,comp_flag,count_neighbors,
			      neighbor_keeper_row,neighbor_keeper_col,
			      nearby_basepair,dot_lower_flag,
			      multicolor_dots_flag,no_partial_flag,
			      annotation_flag,prob_annotation_flag);
  }
  if(post_file!=MAIN_POST) {
    fprintf(postfp,"%s Make Labels  \n","%%");
    fixcolor_plot_postscript(COLOR_LABEL);
    fprintf(postfp," /Helvetica-Bold findfont\n");
    fprintf(postfp," 8 scalefont\n");
    fprintf(postfp," setfont\n");
    for(i=0;i<zoom_labels_count;i++) {
      fprintf(postfp,"%d %d sbox\n", zoom_labels_row[i]-display_t+1,
              zoom_labels_col[i]-display_l+1);
      fprintf(postfp,"\n %d %d moveto", zoom_labels_col[i]-display_l+2,
              display_b-zoom_labels_row[i]+1);
      fprintf(postfp," %f %f scale\n",1/hscale,1/vscale);
      fprintf(postfp," 0 -1.5 rmoveto\n");
      fprintf(postfp," (%s) show \n",zoom_labels_string[i]);
      fprintf(postfp," %f %f scale\n",hscale,vscale);
    }
  }
  fprintf(postfp,"\nshowpage\n");
  fprintf(postfp,"%sEOF\n","%%");
  fclose(postfp);
}
